/*
 * File: Howlers.cs
 * Date: 11 aug 2012
 * Time: 12:59:14
 * Generated by TismTool version 0.9
 */

/*
 * Overview of identifications
 * ---------------------------
 * Ports:
 *     22 ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > pp_checker )
 *     66 ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > pp_howlers )
 *     67 ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > rp_slave )
 *     68 ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > rp_checker )
 *    111 ( Xmi > Data > Protocols > CheckerProtocol > CheckerServer > Port )
 *    121 ( Xmi > Data > Protocols > CheckerProtocol > CheckerClient > Port )
 *    132 ( Xmi > Data > Protocols > SlaveProtocol > SlaveClient > Port )
 *    147 ( Xmi > Data > Protocols > SlaveProtocol > SlaveServer > Port )
 *    163 ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > Port )
 *    191 ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > Port )
 * Triggers:
 *      1 void IChecker___Check()
 *      2 int IHowlers___GetInfo()
 *      3 void IHowlers___Pause()
 *      4 void IHowlers___Slow()
 *      5 void IHowlers___Start()
 *      6 void IHowlers___Stop()
 *      7 void IHowlers___Test()
 *      8 void ICbSlave___CbOutSync()
 *      9 void ICbSlave___CbStarted()
 *     10 void ICbSlave___CbStopped()
 *     11 void ICbChecker___CbChecked()
 *     12 void ISlave___Start()
 *     13 void ISlave___Stop()
 *     14 void ICbHowlers___CbPaused()
 *     15 void ICbHowlers___CbSlowed()
 *     16 void ICbHowlers___CbStarted()
 *     17 void ICbHowlers___CbStopped()
 *     18 void ICbHowlers___CbOutSync()
 * Natives:
 *   -128 ( CheckerClientPsm >> Idle ) ->
 *        ( CheckerClientPsm >> Checking )
 *        Check();
 *   -143 ( SlaveClientPsm >> Idle ) ->
 *        ( SlaveClientPsm >> Starting )
 *        Start();
 *   -144 ( SlaveClientPsm >> Busy ) ->
 *        ( SlaveClientPsm >> Stopping )
 *        Stop();
 *    157 ( SlaveServerPsm >> Starting ) ->
 *        ( SlaveServerPsm >> Busy )
 *        CbStarted();
 *    159 ( SlaveServerPsm >> Stopping ) ->
 *        ( SlaveServerPsm >> Idle )
 *        CbStopped();
 *    160 ( SlaveServerPsm >> Busy ) ->
 *        ( SlaveServerPsm >> Busy )
 *        CbOutSync();
 *   -176 ( HowlersClientPsm >> Active >> Busy ) ->
 *        ( HowlersClientPsm >> JuncState )
 *        Slow();
 *   -179 ( HowlersClientPsm >> Active >> Busy ) ->
 *        ( HowlersClientPsm >> Active >> Test )
 *        Test();
 *   -180 ( HowlersClientPsm >> Active >> Busy ) ->
 *        ( HowlersClientPsm >> Active >> Pausing )
 *        Pause();
 *   -182 ( HowlersClientPsm >> Active >> Starting ) ->
 *        ( HowlersClientPsm >> Active >> Starting )
 *        GetInfo();
 *   -186 ( HowlersClientPsm >> Idle ) ->
 *        ( HowlersClientPsm >> Active >> Starting )
 *        Start();
 *   -189 ( HowlersClientPsm >> Active ) ->
 *        ( HowlersClientPsm >> Stopping )
 *        Stop();
 *    204 ( HowlersServerPsm >> Active >> Pausing ) ->
 *        ( HowlersServerPsm >> Active >> Busy )
 *        CbPaused();
 *    205 ( HowlersServerPsm >> Active >> Busy ) ->
 *        ( HowlersServerPsm >> Active >> OutSync )
 *        CbOutSync();
 *    209 ( HowlersServerPsm >> Active >> Starting ) ->
 *        ( HowlersServerPsm >> Active >> Busy )
 *        CbStarted();
 *    215 ( HowlersServerPsm >> Stopping ) ->
 *        ( HowlersServerPsm >> Idle )
 *        CbStopped();
 */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TsmRTE;

namespace Howlers
{
  public partial class Howlers
  {
    static void ArgsHandle( string[] args )
    {
      for ( int i=0; i<args.Length; i++ )
      {
        char [] ca = args[ i ].ToCharArray();
        if ( ( ca.Length >= 2 ) && ( ca[ 0 ] == '-' ) )
        {
          switch ( ca[1] )
          {
          case 'l' :
            if ( ( ca.Length >= 4 ) && ( ca[ 2 ] == '=' ) )
            {
              int ll = Convert.ToInt32( args[ i ].Substring( 3 ) );
              Tsm.SetLogLevel( ll );
            }
            break;
          case 'C' :
            if ( ca.Length >= 3 )
            {
              Tsm.SetLogConsole( ca[ 2 ] == '+' );
            }
            break;
          case 'L' :
            if ( ca.Length >= 3 )
            {
              Tsm.SetLogFile( ca[ 2 ] == '+' );
            }
            break;
          case 'S' :
            if ( ca.Length >= 3 )
            {
              Tsm.SetSeqFile( ca[ 2 ] == '+' );
            }
            break;
          }
        }
      }
    }

    static void Main( string[] args )
    {
      ArgsHandle( args );
      try
      {
        TsmSystem ts = new TsmSystem( null );
        ts.Activate();
        ts.Execute();
        ts.Deactivate();
      }
      catch ( Exception exc )
      {
        Tsm.Log( "*** TsmSystem Exception ***" );
        Tsm.Log( exc.Message );
        Tsm.Log( exc.StackTrace );
      }
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > HowlersClientPsm >> InitialState )
  public class Ini_0165_0166 : TsmPseudo
  {
    public Ini_0165_0166( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 185, "( HowlersClientPsm >> InitialState ) => ( HowlersClientPsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 185; // TRLS ( HowlersClientPsm >> InitialState ) => ( HowlersClientPsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 185: // UP: ( HowlersClientPsm >> InitialState ) => ( HowlersClientPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > HowlersClientPsm >> JuncState )
  public class Jun_0165_0167 : TsmPseudo
  {
    public Jun_0165_0167( TsmBase oParent )
    {
      TsmName = "JuncState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 187, "( HowlersClientPsm >> JuncState ) => ( HowlersClientPsm >> Active >> Slow )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 187; // TRLS ( HowlersClientPsm >> JuncState ) => ( HowlersClientPsm >> Active >> Slow )
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0169_0176( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 187: // UP: ( HowlersClientPsm >> JuncState ) => ( HowlersClientPsm >> Active >> Slow )
        bHigher = true;
        break;
      case 176:
        Tra_0169_0176( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > HowlersClientPsm >> Active >> Starting )
  public class Lea_0169_0170 : TsmLeaf
  {
    int [] aNatives = { -182 };

    public Lea_0169_0170( TsmBase oParent )
    {
      TsmName = "Starting";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 182, "( HowlersClientPsm >> Active >> Starting ) => ( HowlersClientPsm >> Active >> Starting )" );
      mTransitions[ 1 ] = new TsmTransition( 181, "( HowlersClientPsm >> Active >> Starting ) => ( HowlersClientPsm >> Active >> Busy ) : CbStarted" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0169_0182( TsmHandler oHandler )
    {
      AtExit( oHandler );
      ((Cla_0161_0162)oHandler.Owner).Function_1013( oHandler );
      AtEntry( oHandler );
      oHandler.bTaken = true;
      oHandler.Action = TsmHandlerAction.INITIAL;
    }

    public void Tra_0165_0186( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Port___CbStarted( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 181; // CbStarted
      oHandler.bTaken = true;
      mTransitions[ 1 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 182:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port -1
      case 163:
        switch ( Command )
        {
        case 16:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 182: // Native: ( HowlersClientPsm >> Active >> Starting ) => ( HowlersClientPsm >> Active >> Starting )
          TsmRecorder.AddNative( "( HowlersClientPsm >> Active >> Starting ) => ( HowlersClientPsm >> Active >> Starting ) # GetInfo();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 182;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break; // end of Port -1
      case 163: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 16: // Port___CbStarted
          {
            Port___CbStarted( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 182:
        Tra_0169_0182( oHandler );
        break;
      case 186:
        Tra_0165_0186( oHandler );
        break;
      case 181: // UP: ( HowlersClientPsm >> Active >> Starting ) => ( HowlersClientPsm >> Active >> Busy )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > HowlersClientPsm >> Active >> OutSync )
  public class Lea_0169_0171 : TsmLeaf
  {
    public Lea_0169_0171( TsmBase oParent )
    {
      TsmName = "OutSync";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0169_0178( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 178:
        Tra_0169_0178( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > HowlersClientPsm >> Active >> Slow )
  public class Lea_0169_0172 : TsmLeaf
  {
    public Lea_0169_0172( TsmBase oParent )
    {
      TsmName = "Slow";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    public void Tra_0165_0187( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 187:
        Tra_0165_0187( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > HowlersClientPsm >> Active >> Busy )
  public class Lea_0169_0173 : TsmLeaf
  {
    int [] aNatives = { -176, -179, -180 };

    public Lea_0169_0173( TsmBase oParent )
    {
      TsmName = "Busy";
      TsmParent = oParent;
      mNrTransitions = 4;
      mTransitions = new TsmTransition[ 4 ];
      mTransitions[ 0 ] = new TsmTransition( 176, "( HowlersClientPsm >> Active >> Busy ) => ( HowlersClientPsm >> JuncState )" );
      mTransitions[ 1 ] = new TsmTransition( 179, "( HowlersClientPsm >> Active >> Busy ) => ( HowlersClientPsm >> Active >> Test )" );
      mTransitions[ 2 ] = new TsmTransition( 180, "( HowlersClientPsm >> Active >> Busy ) => ( HowlersClientPsm >> Active >> Pausing )" );
      mTransitions[ 3 ] = new TsmTransition( 178, "( HowlersClientPsm >> Active >> Busy ) => ( HowlersClientPsm >> Active >> OutSync ) : CbOutSync" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0169_0177( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0169_0181( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Port___CbOutSync( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 178; // CbOutSync
      oHandler.bTaken = true;
      mTransitions[ 3 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 176:
          return TsmProspect.OK;
        case 179:
          return TsmProspect.OK;
        case 180:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port -1
      case 163:
        switch ( Command )
        {
        case 18:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 176: // Native: ( HowlersClientPsm >> Active >> Busy ) => ( HowlersClientPsm >> JuncState )
          TsmRecorder.AddNative( "( HowlersClientPsm >> Active >> Busy ) => ( HowlersClientPsm >> JuncState ) # Slow();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 176;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        case 179: // Native: ( HowlersClientPsm >> Active >> Busy ) => ( HowlersClientPsm >> Active >> Test )
          TsmRecorder.AddNative( "( HowlersClientPsm >> Active >> Busy ) => ( HowlersClientPsm >> Active >> Test ) # Test();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 179;
          oHandler.bTaken = true;
          mTransitions[ 1 ].bVisit = true;
          break;
        case 180: // Native: ( HowlersClientPsm >> Active >> Busy ) => ( HowlersClientPsm >> Active >> Pausing )
          TsmRecorder.AddNative( "( HowlersClientPsm >> Active >> Busy ) => ( HowlersClientPsm >> Active >> Pausing ) # Pause();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 180;
          oHandler.bTaken = true;
          mTransitions[ 2 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break; // end of Port -1
      case 163: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 18: // Port___CbOutSync
          {
            Port___CbOutSync( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 176: // UP: ( HowlersClientPsm >> Active >> Busy ) => ( HowlersClientPsm >> JuncState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 179: // UP: ( HowlersClientPsm >> Active >> Busy ) => ( HowlersClientPsm >> Active >> Test )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 180: // UP: ( HowlersClientPsm >> Active >> Busy ) => ( HowlersClientPsm >> Active >> Pausing )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 177:
        Tra_0169_0177( oHandler );
        break;
      case 181:
        Tra_0169_0181( oHandler );
        break;
      case 178: // UP: ( HowlersClientPsm >> Active >> Busy ) => ( HowlersClientPsm >> Active >> OutSync )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > HowlersClientPsm >> Active >> Pausing )
  public class Lea_0169_0174 : TsmLeaf
  {
    public Lea_0169_0174( TsmBase oParent )
    {
      TsmName = "Pausing";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 177, "( HowlersClientPsm >> Active >> Pausing ) => ( HowlersClientPsm >> Active >> Busy ) : CbPaused" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0169_0180( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Port___CbPaused( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 177; // CbPaused
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 163:
        switch ( Command )
        {
        case 14:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 163: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 14: // Port___CbPaused
          {
            Port___CbPaused( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 180:
        Tra_0169_0180( oHandler );
        break;
      case 177: // UP: ( HowlersClientPsm >> Active >> Pausing ) => ( HowlersClientPsm >> Active >> Busy )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > HowlersClientPsm >> Active >> Test )
  public class Lea_0169_0175 : TsmLeaf
  {
    public Lea_0169_0175( TsmBase oParent )
    {
      TsmName = "Test";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0169_0179( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 179:
        Tra_0169_0179( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > HowlersClientPsm >> Active >)
  public class Reg_0168_0169 : TsmRegion
  {
    private Lea_0169_0170 oLea_0169_0170; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > HowlersClientPsm >> Active >> Starting )
    private Lea_0169_0171 oLea_0169_0171; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > HowlersClientPsm >> Active >> OutSync )
    private Lea_0169_0172 oLea_0169_0172; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > HowlersClientPsm >> Active >> Slow )
    private Lea_0169_0173 oLea_0169_0173; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > HowlersClientPsm >> Active >> Busy )
    private Lea_0169_0174 oLea_0169_0174; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > HowlersClientPsm >> Active >> Pausing )
    private Lea_0169_0175 oLea_0169_0175; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > HowlersClientPsm >> Active >> Test )

    public Reg_0168_0169( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oLea_0169_0170 = new Lea_0169_0170( this );
      oLea_0169_0171 = new Lea_0169_0171( this );
      oLea_0169_0172 = new Lea_0169_0172( this );
      oLea_0169_0173 = new Lea_0169_0173( this );
      oLea_0169_0174 = new Lea_0169_0174( this );
      oLea_0169_0175 = new Lea_0169_0175( this );
      mNrStates = 6;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oLea_0169_0170;
      mStates[ 1 ] = oLea_0169_0171;
      mStates[ 2 ] = oLea_0169_0172;
      mStates[ 3 ] = oLea_0169_0173;
      mStates[ 4 ] = oLea_0169_0174;
      mStates[ 5 ] = oLea_0169_0175;
    }

     // Down: ( HowlersClientPsm >> JuncState ) => ( HowlersClientPsm >> Active >> Slow )
    public void Tra_0165_0187( TsmHandler oHandler )
    {
      mCurrentState = oLea_0169_0172; // Down: ( HowlersClientPsm >> Active >> Slow )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersClientPsm >> Active >> Busy ) => ( HowlersClientPsm >> Active >> Test )
    public void Tra_0169_0179( TsmHandler oHandler )
    {
      ((Cla_0161_0162)oHandler.Owner).Function_1015( oHandler );
      mCurrentState = oLea_0169_0175; // At: ( HowlersClientPsm >> Active >> Test )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersClientPsm >> Active >> Busy ) => ( HowlersClientPsm >> Active >> Pausing )
    public void Tra_0169_0180( TsmHandler oHandler )
    {
      ((Cla_0161_0162)oHandler.Owner).Function_1016( oHandler );
      mCurrentState = oLea_0169_0174; // At: ( HowlersClientPsm >> Active >> Pausing )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // Down: ( HowlersClientPsm >> Idle ) => ( HowlersClientPsm >> Active >> Starting )
    public void Tra_0165_0186( TsmHandler oHandler )
    {
      mCurrentState = oLea_0169_0170; // Down: ( HowlersClientPsm >> Active >> Starting )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersClientPsm >> Active >> Pausing ) => ( HowlersClientPsm >> Active >> Busy )
    public void Tra_0169_0177( TsmHandler oHandler )
    {
      mCurrentState = oLea_0169_0173; // At: ( HowlersClientPsm >> Active >> Busy )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersClientPsm >> Active >> Starting ) => ( HowlersClientPsm >> Active >> Busy )
    public void Tra_0169_0181( TsmHandler oHandler )
    {
      mCurrentState = oLea_0169_0173; // At: ( HowlersClientPsm >> Active >> Busy )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersClientPsm >> Active >> Busy ) => ( HowlersClientPsm >> Active >> OutSync )
    public void Tra_0169_0178( TsmHandler oHandler )
    {
      mCurrentState = oLea_0169_0171; // At: ( HowlersClientPsm >> Active >> OutSync )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 182:
          return TsmProspect.OK;
        case 176:
          return TsmProspect.OK;
        case 179:
          return TsmProspect.OK;
        case 180:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port -1
      case 163:
        switch ( Command )
        {
        case 14:
          return TsmProspect.OK;
        case 16:
          return TsmProspect.OK;
        case 18:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 187:
        Tra_0165_0187( oHandler );
        break;
      case 176: // Up: ( HowlersClientPsm >> Active >> Busy ) => ( HowlersClientPsm >> JuncState )
        mCurrentState = null;
        bHigher = true;
        break;
      case 179:
        Tra_0169_0179( oHandler );
        break;
      case 180:
        Tra_0169_0180( oHandler );
        break;
      case 186:
        Tra_0165_0186( oHandler );
        break;
      case 177:
        Tra_0169_0177( oHandler );
        break;
      case 181:
        Tra_0169_0181( oHandler );
        break;
      case 178:
        Tra_0169_0178( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > HowlersClientPsm >> Active )
  public class Com_0165_0168 : TsmCompound
  {
    int [] aNatives = { -189 };
    private Reg_0168_0169 oReg_0168_0169; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > HowlersClientPsm >> Active >)

    public Com_0165_0168( TsmBase oParent )
    {
      TsmName = "Active";
      TsmParent = oParent;
      oReg_0168_0169 = new Reg_0168_0169( this );
      mRegions.Add( oReg_0168_0169 );
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 189, "( HowlersClientPsm >> Active ) => ( HowlersClientPsm >> Stopping )" );
    }

    public void Tra_0165_0187( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      oReg_0168_0169.ExecuteHandler( oHandler );
    }

    public void Tra_0165_0186( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      oReg_0168_0169.ExecuteHandler( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtMyExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 189:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTriggerCompound( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 189: // Native: ( HowlersClientPsm >> Active ) => ( HowlersClientPsm >> Stopping )
          TsmRecorder.AddNative( "( HowlersClientPsm >> Active ) => ( HowlersClientPsm >> Stopping ) # Stop();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 189;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 187:
        Tra_0165_0187( oHandler );
        break;
      case 189: // UP: ( HowlersClientPsm >> Active ) => ( HowlersClientPsm >> Stopping )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 176: // UP: ( HowlersClientPsm >> Active >> Busy ) => ( HowlersClientPsm >> JuncState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 186:
        Tra_0165_0186( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > HowlersClientPsm >> Idle )
  public class Lea_0165_0183 : TsmLeaf
  {
    int [] aNatives = { -186 };

    public Lea_0165_0183( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 186, "( HowlersClientPsm >> Idle ) => ( HowlersClientPsm >> Active >> Starting )" );
    }

    public void Tra_0165_0185( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0165_0188( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 186:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 186: // Native: ( HowlersClientPsm >> Idle ) => ( HowlersClientPsm >> Active >> Starting )
          TsmRecorder.AddNative( "( HowlersClientPsm >> Idle ) => ( HowlersClientPsm >> Active >> Starting ) # Start();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 186;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 185:
        Tra_0165_0185( oHandler );
        break;
      case 186: // UP: ( HowlersClientPsm >> Idle ) => ( HowlersClientPsm >> Active >> Starting )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 188:
        Tra_0165_0188( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > HowlersClientPsm >> Stopping )
  public class Lea_0165_0184 : TsmLeaf
  {
    public Lea_0165_0184( TsmBase oParent )
    {
      TsmName = "Stopping";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 188, "( HowlersClientPsm >> Stopping ) => ( HowlersClientPsm >> Idle ) : CbStopped" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0165_0189( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Port___CbStopped( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 188; // CbStopped
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 163:
        switch ( Command )
        {
        case 17:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 163: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 17: // Port___CbStopped
          {
            Port___CbStopped( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 189:
        Tra_0165_0189( oHandler );
        break;
      case 188: // UP: ( HowlersClientPsm >> Stopping ) => ( HowlersClientPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > HowlersClientPsm >)
  public class Reg_0164_0165 : TsmRegion
  {
    private Ini_0165_0166 oIni_0165_0166; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > HowlersClientPsm >> InitialState )
    private Jun_0165_0167 oJun_0165_0167; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > HowlersClientPsm >> JuncState )
    private Com_0165_0168 oCom_0165_0168; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > HowlersClientPsm >> Active )
    private Lea_0165_0183 oLea_0165_0183; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > HowlersClientPsm >> Idle )
    private Lea_0165_0184 oLea_0165_0184; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > HowlersClientPsm >> Stopping )

    public Reg_0164_0165( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0165_0166 = new Ini_0165_0166( this );
      oJun_0165_0167 = new Jun_0165_0167( this );
      oCom_0165_0168 = new Com_0165_0168( this );
      oLea_0165_0183 = new Lea_0165_0183( this );
      oLea_0165_0184 = new Lea_0165_0184( this );
      mNrStates = 5;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0165_0166;
      mStates[ 1 ] = oJun_0165_0167;
      mStates[ 2 ] = oCom_0165_0168;
      mStates[ 3 ] = oLea_0165_0183;
      mStates[ 4 ] = oLea_0165_0184;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0165_0166.ExecuteHandler( oHandler );
    }

     // At: ( HowlersClientPsm >> InitialState ) => ( HowlersClientPsm >> Idle )
    public void Tra_0165_0185( TsmHandler oHandler )
    {
      mCurrentState = oLea_0165_0183; // At: ( HowlersClientPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersClientPsm >> JuncState ) => ( HowlersClientPsm >> Active >> Slow )
    public void Tra_0165_0187( TsmHandler oHandler )
    {
      mCurrentState = oCom_0165_0168; // At: ( HowlersClientPsm >> Active )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersClientPsm >> Active ) => ( HowlersClientPsm >> Stopping )
    public void Tra_0165_0189( TsmHandler oHandler )
    {
      ((Cla_0161_0162)oHandler.Owner).Function_1012( oHandler );
      mCurrentState = oLea_0165_0184; // At: ( HowlersClientPsm >> Stopping )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersClientPsm >> Active >> Busy ) => ( HowlersClientPsm >> JuncState )
    public void Tra_0169_0176( TsmHandler oHandler )
    {
      ((Cla_0161_0162)oHandler.Owner).Function_1014( oHandler );
      mCurrentState = oJun_0165_0167; // At: ( HowlersClientPsm >> JuncState )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersClientPsm >> Idle ) => ( HowlersClientPsm >> Active >> Starting )
    public void Tra_0165_0186( TsmHandler oHandler )
    {
      ((Cla_0161_0162)oHandler.Owner).Function_1017( oHandler );
      mCurrentState = oCom_0165_0168; // At: ( HowlersClientPsm >> Active )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersClientPsm >> Stopping ) => ( HowlersClientPsm >> Idle )
    public void Tra_0165_0188( TsmHandler oHandler )
    {
      mCurrentState = oLea_0165_0183; // At: ( HowlersClientPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 189:
          return TsmProspect.OK;
        case 182:
          return TsmProspect.OK;
        case 176:
          return TsmProspect.OK;
        case 179:
          return TsmProspect.OK;
        case 180:
          return TsmProspect.OK;
        case 186:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port -1
      case 163:
        switch ( Command )
        {
        case 14:
          return TsmProspect.OK;
        case 16:
          return TsmProspect.OK;
        case 17:
          return TsmProspect.OK;
        case 18:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 185:
        Tra_0165_0185( oHandler );
        break;
      case 187:
        Tra_0165_0187( oHandler );
        break;
      case 189:
        Tra_0165_0189( oHandler );
        break;
      case 176:
        Tra_0169_0176( oHandler );
        break;
      case 186:
        Tra_0165_0186( oHandler );
        break;
      case 188:
        Tra_0165_0188( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > HowlersClientPsm )
  public class Fsm_0162_0164 : TsmFsm
  {
    private Reg_0164_0165 oReg_0164_0165; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > HowlersClientPsm >)

    public Fsm_0162_0164( TsmBase oParent )
    {
      TsmName = "HowlersClientPsm";
      TsmParent = oParent;
      oReg_0164_0165 = new Reg_0164_0165( this );
      mRegions.Add( oReg_0164_0165 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient )
  public class Cla_0161_0162 : TsmProtocolClass
  {
    private Fsm_0162_0164 oFsm_0162_0164; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > HowlersClientPsm )
    private TsmIPort_IHowlers Port; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > Port )
    private TsmIPort_ICbHowlers TsmPI__Port; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > Port )
    private TsmPCPort mPCMessager;

    public Cla_0161_0162( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0162_0164 = new Fsm_0162_0164( this );
      TsmPI__Port = new TsmIPort_ICbHowlers( this );
      mPCMessager = new TsmPCPort();
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0162_0164;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "Port" :
        return TsmPI__Port;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "Port" :
        Port = (TsmIPort_IHowlers) oProvidedInterface;
        Port.Source = this;
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0162_0164.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

     // ( HowlersClientPsm >> Active ) => ( HowlersClientPsm >> Stopping )
    public void Function_1012( TsmHandler oHandler )
    {
      Port.Stop();
    }

     // ( HowlersClientPsm >> Active >> Starting ) => ( HowlersClientPsm >> Active >> Starting )
    public void Function_1013( TsmHandler oHandler )
    {
      Port.GetInfo();
    }

     // ( HowlersClientPsm >> Active >> Busy ) => ( HowlersClientPsm >> JuncState )
    public void Function_1014( TsmHandler oHandler )
    {
      Port.Slow();
    }

     // ( HowlersClientPsm >> Active >> Busy ) => ( HowlersClientPsm >> Active >> Test )
    public void Function_1015( TsmHandler oHandler )
    {
      Port.Test();
    }

     // ( HowlersClientPsm >> Active >> Busy ) => ( HowlersClientPsm >> Active >> Pausing )
    public void Function_1016( TsmHandler oHandler )
    {
      Port.Pause();
    }

     // ( HowlersClientPsm >> Idle ) => ( HowlersClientPsm >> Active >> Starting )
    public void Function_1017( TsmHandler oHandler )
    {
      Port.Start();
    }

    public override void TsmInitialise( object oObject )
    {
      TsmPI__Port.PortId = 163;
      TsmPI__Port.Messager = mPCMessager;
    }

    public override void TsmConnect( object oObject )
    {
      mPCMessager.Target = this;
      mPCMessager.IntQueue = (TsmIntQueue) oObject;
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0162_0164.ExecuteHandler( lHandler );
    }
  }

   // ( Xmi > Data > Architecture > ExecEnv2 > Ui )
  public class Com_0003_0001 : TsmPComponent
  {
    private Cla_0161_0162 InsHowlersClient; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > InsHowlersClient )

    public Com_0003_0001( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsHowlersClient = new Cla_0161_0162( this, "InsHowlersClient" );
      InsHowlersClient.IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass[ 1 ];
      mClasses[ 0 ] = InsHowlersClient;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "rp_howlers" :
        return InsHowlersClient.GetProvidedInterface( "Port" );
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv2 > Ui )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "rp_howlers" :
        InsHowlersClient.SetRequiredInterface( "Port", oProvidedInterface );
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv2 > Ui )";
      throw new TsmException( s );
    }
  }

   // ( Xmi > Data > Protocols > SlaveProtocol > SlaveServer > SlaveServerPsm >> InitialState )
  public class Ini_0149_0150 : TsmPseudo
  {
    public Ini_0149_0150( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 155, "( SlaveServerPsm >> InitialState ) => ( SlaveServerPsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 155; // TRLS ( SlaveServerPsm >> InitialState ) => ( SlaveServerPsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 155: // UP: ( SlaveServerPsm >> InitialState ) => ( SlaveServerPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SlaveProtocol > SlaveServer > SlaveServerPsm >> Idle )
  public class Lea_0149_0151 : TsmLeaf
  {
    public Lea_0149_0151( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 156, "( SlaveServerPsm >> Idle ) => ( SlaveServerPsm >> Starting ) : Start" );
    }

    public void Tra_0149_0155( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0149_0159( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Port___Start( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 156; // Start
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 147:
        switch ( Command )
        {
        case 12:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 147: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 12: // Port___Start
          {
            Port___Start( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 155:
        Tra_0149_0155( oHandler );
        break;
      case 159:
        Tra_0149_0159( oHandler );
        break;
      case 156: // UP: ( SlaveServerPsm >> Idle ) => ( SlaveServerPsm >> Starting )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SlaveProtocol > SlaveServer > SlaveServerPsm >> Starting )
  public class Lea_0149_0152 : TsmLeaf
  {
    int [] aNatives = { 157 };

    public Lea_0149_0152( TsmBase oParent )
    {
      TsmName = "Starting";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 157, "( SlaveServerPsm >> Starting ) => ( SlaveServerPsm >> Busy )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0149_0156( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 157:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 157: // Native: ( SlaveServerPsm >> Starting ) => ( SlaveServerPsm >> Busy )
          TsmRecorder.AddNative( "( SlaveServerPsm >> Starting ) => ( SlaveServerPsm >> Busy ) # CbStarted();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 157;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 157: // UP: ( SlaveServerPsm >> Starting ) => ( SlaveServerPsm >> Busy )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 156:
        Tra_0149_0156( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SlaveProtocol > SlaveServer > SlaveServerPsm >> Busy )
  public class Lea_0149_0153 : TsmLeaf
  {
    int [] aNatives = { 160 };

    public Lea_0149_0153( TsmBase oParent )
    {
      TsmName = "Busy";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 160, "( SlaveServerPsm >> Busy ) => ( SlaveServerPsm >> Busy )" );
      mTransitions[ 1 ] = new TsmTransition( 158, "( SlaveServerPsm >> Busy ) => ( SlaveServerPsm >> Stopping ) : Stop" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0149_0157( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0149_0160( TsmHandler oHandler )
    {
      AtExit( oHandler );
      ((Cla_0130_0146)oHandler.Owner).Function_1010( oHandler );
      AtEntry( oHandler );
      oHandler.bTaken = true;
      oHandler.Action = TsmHandlerAction.INITIAL;
    }

    public void Port___Stop( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 158; // Stop
      oHandler.bTaken = true;
      mTransitions[ 1 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 160:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port -1
      case 147:
        switch ( Command )
        {
        case 13:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 160: // Native: ( SlaveServerPsm >> Busy ) => ( SlaveServerPsm >> Busy )
          TsmRecorder.AddNative( "( SlaveServerPsm >> Busy ) => ( SlaveServerPsm >> Busy ) # CbOutSync();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 160;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break; // end of Port -1
      case 147: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 13: // Port___Stop
          {
            Port___Stop( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 157:
        Tra_0149_0157( oHandler );
        break;
      case 160:
        Tra_0149_0160( oHandler );
        break;
      case 158: // UP: ( SlaveServerPsm >> Busy ) => ( SlaveServerPsm >> Stopping )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SlaveProtocol > SlaveServer > SlaveServerPsm >> Stopping )
  public class Lea_0149_0154 : TsmLeaf
  {
    int [] aNatives = { 159 };

    public Lea_0149_0154( TsmBase oParent )
    {
      TsmName = "Stopping";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 159, "( SlaveServerPsm >> Stopping ) => ( SlaveServerPsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0149_0158( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 159:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 159: // Native: ( SlaveServerPsm >> Stopping ) => ( SlaveServerPsm >> Idle )
          TsmRecorder.AddNative( "( SlaveServerPsm >> Stopping ) => ( SlaveServerPsm >> Idle ) # CbStopped();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 159;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 159: // UP: ( SlaveServerPsm >> Stopping ) => ( SlaveServerPsm >> Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 158:
        Tra_0149_0158( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SlaveProtocol > SlaveServer > SlaveServerPsm >)
  public class Reg_0148_0149 : TsmRegion
  {
    private Ini_0149_0150 oIni_0149_0150; // ( Xmi > Data > Protocols > SlaveProtocol > SlaveServer > SlaveServerPsm >> InitialState )
    private Lea_0149_0151 oLea_0149_0151; // ( Xmi > Data > Protocols > SlaveProtocol > SlaveServer > SlaveServerPsm >> Idle )
    private Lea_0149_0152 oLea_0149_0152; // ( Xmi > Data > Protocols > SlaveProtocol > SlaveServer > SlaveServerPsm >> Starting )
    private Lea_0149_0153 oLea_0149_0153; // ( Xmi > Data > Protocols > SlaveProtocol > SlaveServer > SlaveServerPsm >> Busy )
    private Lea_0149_0154 oLea_0149_0154; // ( Xmi > Data > Protocols > SlaveProtocol > SlaveServer > SlaveServerPsm >> Stopping )

    public Reg_0148_0149( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0149_0150 = new Ini_0149_0150( this );
      oLea_0149_0151 = new Lea_0149_0151( this );
      oLea_0149_0152 = new Lea_0149_0152( this );
      oLea_0149_0153 = new Lea_0149_0153( this );
      oLea_0149_0154 = new Lea_0149_0154( this );
      mNrStates = 5;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0149_0150;
      mStates[ 1 ] = oLea_0149_0151;
      mStates[ 2 ] = oLea_0149_0152;
      mStates[ 3 ] = oLea_0149_0153;
      mStates[ 4 ] = oLea_0149_0154;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0149_0150.ExecuteHandler( oHandler );
    }

     // At: ( SlaveServerPsm >> InitialState ) => ( SlaveServerPsm >> Idle )
    public void Tra_0149_0155( TsmHandler oHandler )
    {
      mCurrentState = oLea_0149_0151; // At: ( SlaveServerPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( SlaveServerPsm >> Starting ) => ( SlaveServerPsm >> Busy )
    public void Tra_0149_0157( TsmHandler oHandler )
    {
      ((Cla_0130_0146)oHandler.Owner).Function_1009( oHandler );
      mCurrentState = oLea_0149_0153; // At: ( SlaveServerPsm >> Busy )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( SlaveServerPsm >> Stopping ) => ( SlaveServerPsm >> Idle )
    public void Tra_0149_0159( TsmHandler oHandler )
    {
      ((Cla_0130_0146)oHandler.Owner).Function_1011( oHandler );
      mCurrentState = oLea_0149_0151; // At: ( SlaveServerPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( SlaveServerPsm >> Idle ) => ( SlaveServerPsm >> Starting )
    public void Tra_0149_0156( TsmHandler oHandler )
    {
      mCurrentState = oLea_0149_0152; // At: ( SlaveServerPsm >> Starting )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( SlaveServerPsm >> Busy ) => ( SlaveServerPsm >> Stopping )
    public void Tra_0149_0158( TsmHandler oHandler )
    {
      mCurrentState = oLea_0149_0154; // At: ( SlaveServerPsm >> Stopping )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 157:
          return TsmProspect.OK;
        case 160:
          return TsmProspect.OK;
        case 159:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port -1
      case 147:
        switch ( Command )
        {
        case 12:
          return TsmProspect.OK;
        case 13:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 155:
        Tra_0149_0155( oHandler );
        break;
      case 157:
        Tra_0149_0157( oHandler );
        break;
      case 159:
        Tra_0149_0159( oHandler );
        break;
      case 156:
        Tra_0149_0156( oHandler );
        break;
      case 158:
        Tra_0149_0158( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SlaveProtocol > SlaveServer > SlaveServerPsm )
  public class Fsm_0146_0148 : TsmFsm
  {
    private Reg_0148_0149 oReg_0148_0149; // ( Xmi > Data > Protocols > SlaveProtocol > SlaveServer > SlaveServerPsm >)

    public Fsm_0146_0148( TsmBase oParent )
    {
      TsmName = "SlaveServerPsm";
      TsmParent = oParent;
      oReg_0148_0149 = new Reg_0148_0149( this );
      mRegions.Add( oReg_0148_0149 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Protocols > SlaveProtocol > SlaveServer )
  public class Cla_0130_0146 : TsmProtocolClass
  {
    private Fsm_0146_0148 oFsm_0146_0148; // ( Xmi > Data > Protocols > SlaveProtocol > SlaveServer > SlaveServerPsm )
    private TsmIPort_ISlave TsmPI__Port; // ( Xmi > Data > Protocols > SlaveProtocol > SlaveServer > Port )
    private TsmIPort_ICbSlave Port; // ( Xmi > Data > Protocols > SlaveProtocol > SlaveServer > Port )
    private TsmPSPort mPSMessager;

    public Cla_0130_0146( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0146_0148 = new Fsm_0146_0148( this );
      TsmPI__Port = new TsmIPort_ISlave( this );
      mPSMessager = new TsmPSPort();
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0146_0148;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "Port" :
        return TsmPI__Port;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > SlaveProtocol > SlaveServer )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "Port" :
        Port = (TsmIPort_ICbSlave) oProvidedInterface;
        Port.Source = this;
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > SlaveProtocol > SlaveServer )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0146_0148.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

     // ( SlaveServerPsm >> Starting ) => ( SlaveServerPsm >> Busy )
    public void Function_1009( TsmHandler oHandler )
    {
      Port.CbStarted();
    }

     // ( SlaveServerPsm >> Busy ) => ( SlaveServerPsm >> Busy )
    public void Function_1010( TsmHandler oHandler )
    {
      Port.CbOutSync();
    }

     // ( SlaveServerPsm >> Stopping ) => ( SlaveServerPsm >> Idle )
    public void Function_1011( TsmHandler oHandler )
    {
      Port.CbStopped();
    }

    public override void TsmInitialise( object oObject )
    {
      TsmPI__Port.PortId = 147;
      TsmPI__Port.Messager = mPSMessager;
    }

    public override void TsmConnect( object oObject )
    {
      mPSMessager.Target = this;
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0146_0148.ExecuteHandler( lHandler );
    }
  }

   // ( Xmi > Data > Architecture > ExecEnv2 > Slave )
  public class Com_0003_0003 : TsmPComponent
  {
    private Cla_0130_0146 InsSlaveServer; // ( Xmi > Data > Protocols > SlaveProtocol > SlaveServer > InsSlaveServer )

    public Com_0003_0003( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsSlaveServer = new Cla_0130_0146( this, "InsSlaveServer" );
      InsSlaveServer.IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass[ 1 ];
      mClasses[ 0 ] = InsSlaveServer;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "pp_slave" :
        return InsSlaveServer.GetProvidedInterface( "Port" );
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv2 > Slave )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "pp_slave" :
        InsSlaveServer.SetRequiredInterface( "Port", oProvidedInterface );
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv2 > Slave )";
      throw new TsmException( s );
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> InitialState )
  public class Ini_0070_0071 : TsmPseudo
  {
    public Ini_0070_0071( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 101, "( HowlersFsm >> InitialState ) => ( HowlersFsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 101; // TRLS ( HowlersFsm >> InitialState ) => ( HowlersFsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 101: // UP: ( HowlersFsm >> InitialState ) => ( HowlersFsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active >> InitialState )
  public class Ini_0073_0074 : TsmPseudo
  {
    public Ini_0073_0074( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 90, "( HowlersFsm >> Active >> InitialState ) => ( HowlersFsm >> Active >> Starting )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 90; // TRLS ( HowlersFsm >> Active >> InitialState ) => ( HowlersFsm >> Active >> Starting )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 90: // UP: ( HowlersFsm >> Active >> InitialState ) => ( HowlersFsm >> Active >> Starting )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active >> JuncState )
  public class Jun_0073_0075 : TsmPseudo
  {
    public Jun_0073_0075( TsmBase oParent )
    {
      TsmName = "JuncState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 105, "( HowlersFsm >> Active >> JuncState ) => ( HowlersFsm >> Active >> Slow )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 105; // TRLS ( HowlersFsm >> Active >> JuncState ) => ( HowlersFsm >> Active >> Slow )
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0073_0091( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 105: // UP: ( HowlersFsm >> Active >> JuncState ) => ( HowlersFsm >> Active >> Slow )
        bHigher = true;
        break;
      case 91:
        Tra_0073_0091( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active >> Starting )
  public class Lea_0073_0076 : TsmLeaf
  {
    public Lea_0073_0076( TsmBase oParent )
    {
      TsmName = "Starting";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 87, "( HowlersFsm >> Active >> Starting ) => ( HowlersFsm >> Active >> Busy ) : rp_slave->CbStarted" );
    }

    public void Tra_0073_0090( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void rp_slave___CbStarted( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 87; // rp_slave.CbStarted
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 67:
        switch ( Command )
        {
        case 9:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 67: // Port rp_slave
        switch ( oHandler.Trigger.Command )
        {
        case 9: // rp_slave___CbStarted
          {
            rp_slave___CbStarted( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 90:
        Tra_0073_0090( oHandler );
        break;
      case 87: // UP: ( HowlersFsm >> Active >> Starting ) => ( HowlersFsm >> Active >> Busy )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active >> OutSync )
  public class Lea_0073_0077 : TsmLeaf
  {
    public Lea_0073_0077( TsmBase oParent )
    {
      TsmName = "OutSync";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0073_0084( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 84:
        Tra_0073_0084( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active >> Slow )
  public class Lea_0073_0078 : TsmLeaf
  {
    public Lea_0073_0078( TsmBase oParent )
    {
      TsmName = "Slow";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    public void Tra_0070_0105( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 105:
        Tra_0070_0105( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active >> Busy )
  public class Lea_0073_0079 : TsmLeaf
  {
    public Lea_0073_0079( TsmBase oParent )
    {
      TsmName = "Busy";
      TsmParent = oParent;
      mNrTransitions = 4;
      mTransitions = new TsmTransition[ 4 ];
      mTransitions[ 0 ] = new TsmTransition( 86, "( HowlersFsm >> Active >> Busy ) => ( HowlersFsm >> Active >> Pausing ) : pp_howlers->Pause" );
      mTransitions[ 1 ] = new TsmTransition( 91, "( HowlersFsm >> Active >> Busy ) => ( HowlersFsm >> Active >> JuncState ) : pp_howlers->Slow" );
      mTransitions[ 2 ] = new TsmTransition( 85, "( HowlersFsm >> Active >> Busy ) => ( HowlersFsm >> Active >> Test ) : pp_howlers->Test" );
      mTransitions[ 3 ] = new TsmTransition( 84, "( HowlersFsm >> Active >> Busy ) => ( HowlersFsm >> Active >> OutSync ) : rp_slave->CbOutSync" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0073_0083( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void pp_howlers___Pause( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 86; // pp_howlers.Pause
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public void pp_howlers___Slow( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 91; // pp_howlers.Slow
      oHandler.bTaken = true;
      mTransitions[ 1 ].bVisit = true;
    }

    public void pp_howlers___Test( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 85; // pp_howlers.Test
      oHandler.bTaken = true;
      mTransitions[ 2 ].bVisit = true;
    }

    public void rp_slave___CbOutSync( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 84; // rp_slave.CbOutSync
      oHandler.bTaken = true;
      mTransitions[ 3 ].bVisit = true;
    }

    public void Tra_0073_0087( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 66:
        switch ( Command )
        {
        case 3:
          return TsmProspect.OK;
        case 4:
          return TsmProspect.OK;
        case 7:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port 66
      case 67:
        switch ( Command )
        {
        case 8:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 66: // Port pp_howlers
        switch ( oHandler.Trigger.Command )
        {
        case 3: // pp_howlers___Pause
          {
            pp_howlers___Pause( oHandler );
          }
          break;
        case 4: // pp_howlers___Slow
          {
            pp_howlers___Slow( oHandler );
          }
          break;
        case 7: // pp_howlers___Test
          {
            pp_howlers___Test( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break; // end of Port 66
      case 67: // Port rp_slave
        switch ( oHandler.Trigger.Command )
        {
        case 8: // rp_slave___CbOutSync
          {
            rp_slave___CbOutSync( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 83:
        Tra_0073_0083( oHandler );
        break;
      case 86: // UP: ( HowlersFsm >> Active >> Busy ) => ( HowlersFsm >> Active >> Pausing )
        bHigher = true;
        break;
      case 91: // UP: ( HowlersFsm >> Active >> Busy ) => ( HowlersFsm >> Active >> JuncState )
        bHigher = true;
        break;
      case 85: // UP: ( HowlersFsm >> Active >> Busy ) => ( HowlersFsm >> Active >> Test )
        bHigher = true;
        break;
      case 84: // UP: ( HowlersFsm >> Active >> Busy ) => ( HowlersFsm >> Active >> OutSync )
        bHigher = true;
        break;
      case 87:
        Tra_0073_0087( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active >> Pausing )
  public class Lea_0073_0080 : TsmLeaf
  {
    public Lea_0073_0080( TsmBase oParent )
    {
      TsmName = "Pausing";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 83, "( HowlersFsm >> Active >> Pausing ) => ( HowlersFsm >> Active >> Busy )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 83; // TRLS ( HowlersFsm >> Active >> Pausing ) => ( HowlersFsm >> Active >> Busy )
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0073_0086( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 83: // UP: ( HowlersFsm >> Active >> Pausing ) => ( HowlersFsm >> Active >> Busy )
        bHigher = true;
        break;
      case 86:
        Tra_0073_0086( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active >> Test )
  public class Lea_0073_0081 : TsmLeaf
  {
    public Lea_0073_0081( TsmBase oParent )
    {
      TsmName = "Test";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 88, "( HowlersFsm >> Active >> Test ) => ( HowlersFsm >> Active >> Again )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 88; // TRLS ( HowlersFsm >> Active >> Test ) => ( HowlersFsm >> Active >> Again )
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0073_0085( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0073_0089( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 88: // UP: ( HowlersFsm >> Active >> Test ) => ( HowlersFsm >> Active >> Again )
        bHigher = true;
        break;
      case 85:
        Tra_0073_0085( oHandler );
        break;
      case 89:
        Tra_0073_0089( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active >> Again )
  public class Lea_0073_0082 : TsmLeaf
  {
    public Lea_0073_0082( TsmBase oParent )
    {
      TsmName = "Again";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 89, "( HowlersFsm >> Active >> Again ) => ( HowlersFsm >> Active >> Test ) : rp_checker->CbChecked" );
    }

    public void Tra_0073_0088( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void rp_checker___CbChecked( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 89; // rp_checker.CbChecked
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 68:
        switch ( Command )
        {
        case 11:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 68: // Port rp_checker
        switch ( oHandler.Trigger.Command )
        {
        case 11: // rp_checker___CbChecked
          {
            rp_checker___CbChecked( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 88:
        Tra_0073_0088( oHandler );
        break;
      case 89: // UP: ( HowlersFsm >> Active >> Again ) => ( HowlersFsm >> Active >> Test )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active >)
  public class Reg_0072_0073 : TsmRegion
  {
    private Ini_0073_0074 oIni_0073_0074; // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active >> InitialState )
    private Jun_0073_0075 oJun_0073_0075; // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active >> JuncState )
    private Lea_0073_0076 oLea_0073_0076; // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active >> Starting )
    private Lea_0073_0077 oLea_0073_0077; // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active >> OutSync )
    private Lea_0073_0078 oLea_0073_0078; // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active >> Slow )
    private Lea_0073_0079 oLea_0073_0079; // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active >> Busy )
    private Lea_0073_0080 oLea_0073_0080; // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active >> Pausing )
    private Lea_0073_0081 oLea_0073_0081; // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active >> Test )
    private Lea_0073_0082 oLea_0073_0082; // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active >> Again )

    public Reg_0072_0073( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0073_0074 = new Ini_0073_0074( this );
      oJun_0073_0075 = new Jun_0073_0075( this );
      oLea_0073_0076 = new Lea_0073_0076( this );
      oLea_0073_0077 = new Lea_0073_0077( this );
      oLea_0073_0078 = new Lea_0073_0078( this );
      oLea_0073_0079 = new Lea_0073_0079( this );
      oLea_0073_0080 = new Lea_0073_0080( this );
      oLea_0073_0081 = new Lea_0073_0081( this );
      oLea_0073_0082 = new Lea_0073_0082( this );
      mNrStates = 9;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0073_0074;
      mStates[ 1 ] = oJun_0073_0075;
      mStates[ 2 ] = oLea_0073_0076;
      mStates[ 3 ] = oLea_0073_0077;
      mStates[ 4 ] = oLea_0073_0078;
      mStates[ 5 ] = oLea_0073_0079;
      mStates[ 6 ] = oLea_0073_0080;
      mStates[ 7 ] = oLea_0073_0081;
      mStates[ 8 ] = oLea_0073_0082;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0073_0074.ExecuteHandler( oHandler );
    }

     // At: ( HowlersFsm >> Active >> InitialState ) => ( HowlersFsm >> Active >> Starting )
    public void Tra_0073_0090( TsmHandler oHandler )
    {
      mCurrentState = oLea_0073_0076; // At: ( HowlersFsm >> Active >> Starting )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersFsm >> Active >> JuncState ) => ( HowlersFsm >> Active >> Slow )
    public void Tra_0070_0105( TsmHandler oHandler )
    {
      ((Cla_0063_0065)oHandler.Owner).Function_1002( oHandler );
      mCurrentState = oLea_0073_0078; // At: ( HowlersFsm >> Active >> Slow )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersFsm >> Active >> Pausing ) => ( HowlersFsm >> Active >> Busy )
    public void Tra_0073_0083( TsmHandler oHandler )
    {
      ((Cla_0063_0065)oHandler.Owner).Function_1003( oHandler );
      mCurrentState = oLea_0073_0079; // At: ( HowlersFsm >> Active >> Busy )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersFsm >> Active >> Test ) => ( HowlersFsm >> Active >> Again )
    public void Tra_0073_0088( TsmHandler oHandler )
    {
      ((Cla_0063_0065)oHandler.Owner).Function_1004( oHandler );
      mCurrentState = oLea_0073_0082; // At: ( HowlersFsm >> Active >> Again )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersFsm >> Active >> Busy ) => ( HowlersFsm >> Active >> Pausing )
    public void Tra_0073_0086( TsmHandler oHandler )
    {
      mCurrentState = oLea_0073_0080; // At: ( HowlersFsm >> Active >> Pausing )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersFsm >> Active >> Busy ) => ( HowlersFsm >> Active >> JuncState )
    public void Tra_0073_0091( TsmHandler oHandler )
    {
      ((Cla_0063_0065)oHandler.Owner).Function_1022( oHandler );
      mCurrentState = oJun_0073_0075; // At: ( HowlersFsm >> Active >> JuncState )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersFsm >> Active >> Busy ) => ( HowlersFsm >> Active >> Test )
    public void Tra_0073_0085( TsmHandler oHandler )
    {
      mCurrentState = oLea_0073_0081; // At: ( HowlersFsm >> Active >> Test )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersFsm >> Active >> Busy ) => ( HowlersFsm >> Active >> OutSync )
    public void Tra_0073_0084( TsmHandler oHandler )
    {
      ((Cla_0063_0065)oHandler.Owner).Function_1025( oHandler );
      mCurrentState = oLea_0073_0077; // At: ( HowlersFsm >> Active >> OutSync )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersFsm >> Active >> Starting ) => ( HowlersFsm >> Active >> Busy )
    public void Tra_0073_0087( TsmHandler oHandler )
    {
      ((Cla_0063_0065)oHandler.Owner).Function_1026( oHandler );
      mCurrentState = oLea_0073_0079; // At: ( HowlersFsm >> Active >> Busy )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersFsm >> Active >> Again ) => ( HowlersFsm >> Active >> Test )
    public void Tra_0073_0089( TsmHandler oHandler )
    {
      mCurrentState = oLea_0073_0081; // At: ( HowlersFsm >> Active >> Test )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 66:
        switch ( Command )
        {
        case 3:
          return TsmProspect.OK;
        case 4:
          return TsmProspect.OK;
        case 7:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port 66
      case 67:
        switch ( Command )
        {
        case 8:
          return TsmProspect.OK;
        case 9:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port 67
      case 68:
        switch ( Command )
        {
        case 11:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 90:
        Tra_0073_0090( oHandler );
        break;
      case 105:
        Tra_0070_0105( oHandler );
        break;
      case 83:
        Tra_0073_0083( oHandler );
        break;
      case 88:
        Tra_0073_0088( oHandler );
        break;
      case 86:
        Tra_0073_0086( oHandler );
        break;
      case 91:
        Tra_0073_0091( oHandler );
        break;
      case 85:
        Tra_0073_0085( oHandler );
        break;
      case 84:
        Tra_0073_0084( oHandler );
        break;
      case 87:
        Tra_0073_0087( oHandler );
        break;
      case 89:
        Tra_0073_0089( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active >> InitialState )
  public class Ini_0092_0093 : TsmPseudo
  {
    public Ini_0092_0093( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 96, "( HowlersFsm >> Active >> InitialState ) => ( HowlersFsm >> Active >> Wait )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 96; // TRLS ( HowlersFsm >> Active >> InitialState ) => ( HowlersFsm >> Active >> Wait )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 96: // UP: ( HowlersFsm >> Active >> InitialState ) => ( HowlersFsm >> Active >> Wait )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active >> Wait )
  public class Lea_0092_0094 : TsmLeaf
  {
    public Lea_0092_0094( TsmBase oParent )
    {
      TsmName = "Wait";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 97, "( HowlersFsm >> Active >> Wait ) => ( HowlersFsm >> Active >> Info ) : rp_slave->CbStarted" );
    }

    public void Tra_0092_0096( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void rp_slave___CbStarted( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 97; // rp_slave.CbStarted
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 67:
        switch ( Command )
        {
        case 9:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 67: // Port rp_slave
        switch ( oHandler.Trigger.Command )
        {
        case 9: // rp_slave___CbStarted
          {
            rp_slave___CbStarted( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 96:
        Tra_0092_0096( oHandler );
        break;
      case 97: // UP: ( HowlersFsm >> Active >> Wait ) => ( HowlersFsm >> Active >> Info )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active >> Info )
  public class Lea_0092_0095 : TsmLeaf
  {
    public Lea_0092_0095( TsmBase oParent )
    {
      TsmName = "Info";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 98, "( HowlersFsm >> Active >> Info ) => ( HowlersFsm >> Active >> Info ) : pp_howlers->GetInfo" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0092_0098( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      oHandler.bTaken = true;
      oHandler.Action = TsmHandlerAction.INITIAL;
    }

    public void pp_howlers___GetInfo( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 98; // pp_howlers.GetInfo
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0092_0097( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 66:
        switch ( Command )
        {
        case 2:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 66: // Port pp_howlers
        switch ( oHandler.Trigger.Command )
        {
        case 2: // pp_howlers___GetInfo
          {
            pp_howlers___GetInfo( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 98:
        Tra_0092_0098( oHandler );
        break;
      case 97:
        Tra_0092_0097( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active >)
  public class Reg_0072_0092 : TsmRegion
  {
    private Ini_0092_0093 oIni_0092_0093; // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active >> InitialState )
    private Lea_0092_0094 oLea_0092_0094; // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active >> Wait )
    private Lea_0092_0095 oLea_0092_0095; // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active >> Info )

    public Reg_0072_0092( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0092_0093 = new Ini_0092_0093( this );
      oLea_0092_0094 = new Lea_0092_0094( this );
      oLea_0092_0095 = new Lea_0092_0095( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0092_0093;
      mStates[ 1 ] = oLea_0092_0094;
      mStates[ 2 ] = oLea_0092_0095;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0092_0093.ExecuteHandler( oHandler );
    }

     // At: ( HowlersFsm >> Active >> InitialState ) => ( HowlersFsm >> Active >> Wait )
    public void Tra_0092_0096( TsmHandler oHandler )
    {
      mCurrentState = oLea_0092_0094; // At: ( HowlersFsm >> Active >> Wait )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersFsm >> Active >> Wait ) => ( HowlersFsm >> Active >> Info )
    public void Tra_0092_0097( TsmHandler oHandler )
    {
      mCurrentState = oLea_0092_0095; // At: ( HowlersFsm >> Active >> Info )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 66:
        switch ( Command )
        {
        case 2:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port 66
      case 67:
        switch ( Command )
        {
        case 9:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 96:
        Tra_0092_0096( oHandler );
        break;
      case 97:
        Tra_0092_0097( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active )
  public class Com_0070_0072 : TsmCompound
  {
    private Reg_0072_0073 oReg_0072_0073; // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active >)
    private Reg_0072_0092 oReg_0072_0092; // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active >)

    public Com_0070_0072( TsmBase oParent )
    {
      TsmName = "Active";
      TsmParent = oParent;
      oReg_0072_0073 = new Reg_0072_0073( this );
      oReg_0072_0092 = new Reg_0072_0092( this );
      mRegions.Add( oReg_0072_0073 );
      mRegions.Add( oReg_0072_0092 );
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 103, "( HowlersFsm >> Active ) => ( HowlersFsm >> Stopping ) : pp_howlers->Stop" );
    }

    public void Tra_0070_0104( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void pp_howlers___Stop( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 103; // pp_howlers.Stop
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 66:
        switch ( Command )
        {
        case 6:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTriggerCompound( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 66: // Port pp_howlers
        switch ( oHandler.Trigger.Command )
        {
        case 6: // pp_howlers___Stop
          {
            pp_howlers___Stop( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 104:
        Tra_0070_0104( oHandler );
        break;
      case 103: // UP: ( HowlersFsm >> Active ) => ( HowlersFsm >> Stopping )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Idle )
  public class Lea_0070_0099 : TsmLeaf
  {
    public Lea_0070_0099( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 104, "( HowlersFsm >> Idle ) => ( HowlersFsm >> Active ) : pp_howlers->Start" );
    }

    public void Tra_0070_0101( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void pp_howlers___Start( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 104; // pp_howlers.Start
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0070_0102( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 66:
        switch ( Command )
        {
        case 5:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 66: // Port pp_howlers
        switch ( oHandler.Trigger.Command )
        {
        case 5: // pp_howlers___Start
          {
            pp_howlers___Start( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 101:
        Tra_0070_0101( oHandler );
        break;
      case 104: // UP: ( HowlersFsm >> Idle ) => ( HowlersFsm >> Active )
        bHigher = true;
        break;
      case 102:
        Tra_0070_0102( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Stopping )
  public class Lea_0070_0100 : TsmLeaf
  {
    public Lea_0070_0100( TsmBase oParent )
    {
      TsmName = "Stopping";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 102, "( HowlersFsm >> Stopping ) => ( HowlersFsm >> Idle ) : rp_slave->CbStopped" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0070_0103( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void rp_slave___CbStopped( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 102; // rp_slave.CbStopped
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 67:
        switch ( Command )
        {
        case 10:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 67: // Port rp_slave
        switch ( oHandler.Trigger.Command )
        {
        case 10: // rp_slave___CbStopped
          {
            rp_slave___CbStopped( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 103:
        Tra_0070_0103( oHandler );
        break;
      case 102: // UP: ( HowlersFsm >> Stopping ) => ( HowlersFsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >)
  public class Reg_0069_0070 : TsmRegion
  {
    private Ini_0070_0071 oIni_0070_0071; // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> InitialState )
    private Com_0070_0072 oCom_0070_0072; // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Active )
    private Lea_0070_0099 oLea_0070_0099; // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Idle )
    private Lea_0070_0100 oLea_0070_0100; // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >> Stopping )

    public Reg_0069_0070( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0070_0071 = new Ini_0070_0071( this );
      oCom_0070_0072 = new Com_0070_0072( this );
      oLea_0070_0099 = new Lea_0070_0099( this );
      oLea_0070_0100 = new Lea_0070_0100( this );
      mNrStates = 4;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0070_0071;
      mStates[ 1 ] = oCom_0070_0072;
      mStates[ 2 ] = oLea_0070_0099;
      mStates[ 3 ] = oLea_0070_0100;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0070_0071.ExecuteHandler( oHandler );
    }

     // At: ( HowlersFsm >> InitialState ) => ( HowlersFsm >> Idle )
    public void Tra_0070_0101( TsmHandler oHandler )
    {
      mCurrentState = oLea_0070_0099; // At: ( HowlersFsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersFsm >> Idle ) => ( HowlersFsm >> Active )
    public void Tra_0070_0104( TsmHandler oHandler )
    {
      ((Cla_0063_0065)oHandler.Owner).Function_1023( oHandler );
      mCurrentState = oCom_0070_0072; // At: ( HowlersFsm >> Active )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersFsm >> Active ) => ( HowlersFsm >> Stopping )
    public void Tra_0070_0103( TsmHandler oHandler )
    {
      ((Cla_0063_0065)oHandler.Owner).Function_1024( oHandler );
      mCurrentState = oLea_0070_0100; // At: ( HowlersFsm >> Stopping )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersFsm >> Stopping ) => ( HowlersFsm >> Idle )
    public void Tra_0070_0102( TsmHandler oHandler )
    {
      ((Cla_0063_0065)oHandler.Owner).Function_1027( oHandler );
      mCurrentState = oLea_0070_0099; // At: ( HowlersFsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 66:
        switch ( Command )
        {
        case 2:
          return TsmProspect.OK;
        case 3:
          return TsmProspect.OK;
        case 4:
          return TsmProspect.OK;
        case 5:
          return TsmProspect.OK;
        case 6:
          return TsmProspect.OK;
        case 7:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port 66
      case 67:
        switch ( Command )
        {
        case 8:
          return TsmProspect.OK;
        case 9:
          return TsmProspect.OK;
        case 10:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port 67
      case 68:
        switch ( Command )
        {
        case 11:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 101:
        Tra_0070_0101( oHandler );
        break;
      case 104:
        Tra_0070_0104( oHandler );
        break;
      case 103:
        Tra_0070_0103( oHandler );
        break;
      case 102:
        Tra_0070_0102( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm )
  public class Fsm_0065_0069 : TsmFsm
  {
    private Reg_0069_0070 oReg_0069_0070; // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm >)

    public Fsm_0065_0069( TsmBase oParent )
    {
      TsmName = "HowlersFsm";
      TsmParent = oParent;
      oReg_0069_0070 = new Reg_0069_0070( this );
      mRegions.Add( oReg_0069_0070 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass )
  public class Cla_0063_0065 : TsmClass
  {
    private Fsm_0065_0069 oFsm_0065_0069; // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > HowlersFsm )
    private TsmIPort_IHowlers TsmPI__pp_howlers; // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > pp_howlers )
    private TsmIPort_ICbHowlers pp_howlers; // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > pp_howlers )
    private TsmIPort_ISlave rp_slave; // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > rp_slave )
    private TsmIPort_ICbSlave TsmPI__rp_slave; // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > rp_slave )
    private TsmIPort_IChecker rp_checker; // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > rp_checker )
    private TsmIPort_ICbChecker TsmPI__rp_checker; // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass > rp_checker )
    private TsmPSPort mPSMessager;
    private TsmPCPort mPCMessager;

    public Cla_0063_0065( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0065_0069 = new Fsm_0065_0069( this );
      TsmPI__pp_howlers = new TsmIPort_IHowlers( this );
      TsmPI__rp_slave = new TsmIPort_ICbSlave( this );
      TsmPI__rp_checker = new TsmIPort_ICbChecker( this );
      mPSMessager = new TsmPSPort();
      mPCMessager = new TsmPCPort();
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0065_0069;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "pp_howlers" :
        return TsmPI__pp_howlers;
      case "rp_slave" :
        return TsmPI__rp_slave;
      case "rp_checker" :
        return TsmPI__rp_checker;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "pp_howlers" :
        pp_howlers = (TsmIPort_ICbHowlers) oProvidedInterface;
        pp_howlers.Source = this;
        return;
      case "rp_slave" :
        rp_slave = (TsmIPort_ISlave) oProvidedInterface;
        rp_slave.Source = this;
        return;
      case "rp_checker" :
        rp_checker = (TsmIPort_IChecker) oProvidedInterface;
        rp_checker.Source = this;
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > HowlersClass )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0065_0069.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

     // ( HowlersFsm >> Active >> JuncState ) => ( HowlersFsm >> Active >> Slow )
    public void Function_1002( TsmHandler oHandler )
    {
      oHandler.Trigger.Ready();
    }

     // ( HowlersFsm >> Active >> Pausing ) => ( HowlersFsm >> Active >> Busy )
    public void Function_1003( TsmHandler oHandler )
    {
      pp_howlers.CbPaused();
    }

     // ( HowlersFsm >> Active >> Test ) => ( HowlersFsm >> Active >> Again )
    public void Function_1004( TsmHandler oHandler )
    {
      rp_checker.Check();
    }

     // ( HowlersFsm >> Active >> Busy ) => ( HowlersFsm >> Active >> JuncState )
    public void Function_1022( TsmHandler oHandler )
    {
      oHandler.Trigger.Ready();
    }

     // ( HowlersFsm >> Idle ) => ( HowlersFsm >> Active )
    public void Function_1023( TsmHandler oHandler )
    {
      rp_slave.Start();
      oHandler.Trigger.Ready();
    }

     // ( HowlersFsm >> Active ) => ( HowlersFsm >> Stopping )
    public void Function_1024( TsmHandler oHandler )
    {
      rp_slave.Stop();
    }

     // ( HowlersFsm >> Active >> Busy ) => ( HowlersFsm >> Active >> OutSync )
    public void Function_1025( TsmHandler oHandler )
    {
      pp_howlers.CbOutSync();
      oHandler.Trigger.Ready();
    }

     // ( HowlersFsm >> Active >> Starting ) => ( HowlersFsm >> Active >> Busy )
    public void Function_1026( TsmHandler oHandler )
    {
      pp_howlers.CbStarted();
    }

     // ( HowlersFsm >> Stopping ) => ( HowlersFsm >> Idle )
    public void Function_1027( TsmHandler oHandler )
    {
      pp_howlers.CbStopped();
    }

    public override void TsmInitialise( object oObject )
    {
      TsmPI__pp_howlers.PortId = 66;
      TsmPI__pp_howlers.Messager = mPSMessager;
      TsmPI__rp_slave.PortId = 67;
      TsmPI__rp_slave.Messager = mPCMessager;
      TsmPI__rp_checker.PortId = 68;
      TsmPI__rp_checker.Messager = mPCMessager;
    }

    public override void TsmConnect( object oObject )
    {
      mPSMessager.Target = this;
      mPCMessager.Target = this;
      mPCMessager.IntQueue = (TsmIntQueue) oObject;
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0065_0069.ExecuteHandler( lHandler );
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent )
  public class Com_0018_0063 : TsmPComponent
  {
    private Cla_0063_0065 Howlers; // ( Xmi > Data > Repository > HowlersPackage > HowlersComponent > Howlers )

    public Com_0018_0063( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      Howlers = new Cla_0063_0065( this, "Howlers" );
      mNrClasses = 1;
      mClasses = new TsmClass[ 1 ];
      mClasses[ 0 ] = Howlers;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "d_pp_howlers" :
        return Howlers.GetProvidedInterface( "pp_howlers" );
      case "d_rp_slave" :
        return Howlers.GetProvidedInterface( "rp_slave" );
      case "d_rp_checker" :
        return Howlers.GetProvidedInterface( "rp_checker" );
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > HowlersPackage > HowlersComponent )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "d_pp_howlers" :
        Howlers.SetRequiredInterface( "pp_howlers", oProvidedInterface );
        return;
      case "d_rp_slave" :
        Howlers.SetRequiredInterface( "rp_slave", oProvidedInterface );
        return;
      case "d_rp_checker" :
        Howlers.SetRequiredInterface( "rp_checker", oProvidedInterface );
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > HowlersPackage > HowlersComponent )";
      throw new TsmException( s );
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > System2 )
  public class Com_0018_0106 : TsmLComponent
  {
    private Com_0018_0063 Howlers; // ( Xmi > Data > Repository > HowlersPackage > System2 > Howlers )

    public Com_0018_0106( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      Howlers = new Com_0018_0063( this, "Howlers" );
      mNrComponents = 1;
      mComponents = new TsmComponent[ 1 ];
      mComponents[ 0 ] = Howlers;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "pp_howlers" :
        return Howlers.GetProvidedInterface( "d_pp_howlers" );
      case "rp_slave" :
        return Howlers.GetProvidedInterface( "d_rp_slave" );
      case "rp_checker" :
        return Howlers.GetProvidedInterface( "d_rp_checker" );
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > HowlersPackage > System2 )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "pp_howlers" :
        Howlers.SetRequiredInterface( "d_pp_howlers", oProvidedInterface );
        return;
      case "rp_slave" :
        Howlers.SetRequiredInterface( "d_rp_slave", oProvidedInterface );
        return;
      case "rp_checker" :
        Howlers.SetRequiredInterface( "d_rp_checker", oProvidedInterface );
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > HowlersPackage > System2 )";
      throw new TsmException( s );
    }
  }

   // ( Xmi > Data > Protocols > CheckerProtocol > CheckerServer > CheckerServerPsm >> InitialState )
  public class Ini_0113_0114 : TsmPseudo
  {
    public Ini_0113_0114( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 117, "( CheckerServerPsm >> InitialState ) => ( CheckerServerPsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 117; // TRLS ( CheckerServerPsm >> InitialState ) => ( CheckerServerPsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 117: // UP: ( CheckerServerPsm >> InitialState ) => ( CheckerServerPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > CheckerProtocol > CheckerServer > CheckerServerPsm >> Idle )
  public class Lea_0113_0115 : TsmLeaf
  {
    public Lea_0113_0115( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 118, "( CheckerServerPsm >> Idle ) => ( CheckerServerPsm >> Checking ) : Check" );
    }

    public void Tra_0113_0117( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0113_0119( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Port___Check( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 118; // Check
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 111:
        switch ( Command )
        {
        case 1:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 111: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 1: // Port___Check
          {
            Port___Check( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 117:
        Tra_0113_0117( oHandler );
        break;
      case 119:
        Tra_0113_0119( oHandler );
        break;
      case 118: // UP: ( CheckerServerPsm >> Idle ) => ( CheckerServerPsm >> Checking )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > CheckerProtocol > CheckerServer > CheckerServerPsm >> Checking )
  public class Lea_0113_0116 : TsmLeaf
  {
    public Lea_0113_0116( TsmBase oParent )
    {
      TsmName = "Checking";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 119, "( CheckerServerPsm >> Checking ) => ( CheckerServerPsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 119; // TRLS ( CheckerServerPsm >> Checking ) => ( CheckerServerPsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0113_0118( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 119: // UP: ( CheckerServerPsm >> Checking ) => ( CheckerServerPsm >> Idle )
        bHigher = true;
        break;
      case 118:
        Tra_0113_0118( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > CheckerProtocol > CheckerServer > CheckerServerPsm >)
  public class Reg_0112_0113 : TsmRegion
  {
    private Ini_0113_0114 oIni_0113_0114; // ( Xmi > Data > Protocols > CheckerProtocol > CheckerServer > CheckerServerPsm >> InitialState )
    private Lea_0113_0115 oLea_0113_0115; // ( Xmi > Data > Protocols > CheckerProtocol > CheckerServer > CheckerServerPsm >> Idle )
    private Lea_0113_0116 oLea_0113_0116; // ( Xmi > Data > Protocols > CheckerProtocol > CheckerServer > CheckerServerPsm >> Checking )

    public Reg_0112_0113( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0113_0114 = new Ini_0113_0114( this );
      oLea_0113_0115 = new Lea_0113_0115( this );
      oLea_0113_0116 = new Lea_0113_0116( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0113_0114;
      mStates[ 1 ] = oLea_0113_0115;
      mStates[ 2 ] = oLea_0113_0116;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0113_0114.ExecuteHandler( oHandler );
    }

     // At: ( CheckerServerPsm >> InitialState ) => ( CheckerServerPsm >> Idle )
    public void Tra_0113_0117( TsmHandler oHandler )
    {
      mCurrentState = oLea_0113_0115; // At: ( CheckerServerPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( CheckerServerPsm >> Checking ) => ( CheckerServerPsm >> Idle )
    public void Tra_0113_0119( TsmHandler oHandler )
    {
      ((Cla_0109_0110)oHandler.Owner).Function_1005( oHandler );
      mCurrentState = oLea_0113_0115; // At: ( CheckerServerPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( CheckerServerPsm >> Idle ) => ( CheckerServerPsm >> Checking )
    public void Tra_0113_0118( TsmHandler oHandler )
    {
      mCurrentState = oLea_0113_0116; // At: ( CheckerServerPsm >> Checking )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 111:
        switch ( Command )
        {
        case 1:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 117:
        Tra_0113_0117( oHandler );
        break;
      case 119:
        Tra_0113_0119( oHandler );
        break;
      case 118:
        Tra_0113_0118( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > CheckerProtocol > CheckerServer > CheckerServerPsm )
  public class Fsm_0110_0112 : TsmFsm
  {
    private Reg_0112_0113 oReg_0112_0113; // ( Xmi > Data > Protocols > CheckerProtocol > CheckerServer > CheckerServerPsm >)

    public Fsm_0110_0112( TsmBase oParent )
    {
      TsmName = "CheckerServerPsm";
      TsmParent = oParent;
      oReg_0112_0113 = new Reg_0112_0113( this );
      mRegions.Add( oReg_0112_0113 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Protocols > CheckerProtocol > CheckerServer )
  public class Cla_0109_0110 : TsmProtocolClass
  {
    private Fsm_0110_0112 oFsm_0110_0112; // ( Xmi > Data > Protocols > CheckerProtocol > CheckerServer > CheckerServerPsm )
    private TsmIPort_IChecker TsmPI__Port; // ( Xmi > Data > Protocols > CheckerProtocol > CheckerServer > Port )
    private TsmIPort_ICbChecker Port; // ( Xmi > Data > Protocols > CheckerProtocol > CheckerServer > Port )
    private TsmPSPort mPSMessager;

    public Cla_0109_0110( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0110_0112 = new Fsm_0110_0112( this );
      TsmPI__Port = new TsmIPort_IChecker( this );
      mPSMessager = new TsmPSPort();
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0110_0112;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "Port" :
        return TsmPI__Port;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > CheckerProtocol > CheckerServer )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "Port" :
        Port = (TsmIPort_ICbChecker) oProvidedInterface;
        Port.Source = this;
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > CheckerProtocol > CheckerServer )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0110_0112.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

     // ( CheckerServerPsm >> Checking ) => ( CheckerServerPsm >> Idle )
    public void Function_1005( TsmHandler oHandler )
    {
      Port.CbChecked();
    }

    public override void TsmInitialise( object oObject )
    {
      TsmPI__Port.PortId = 111;
      TsmPI__Port.Messager = mPSMessager;
    }

    public override void TsmConnect( object oObject )
    {
      mPSMessager.Target = this;
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0110_0112.ExecuteHandler( lHandler );
    }
  }

   // ( Xmi > Data > Architecture > ExecEnv2 > Checker )
  public class Com_0003_0005 : TsmPComponent
  {
    private Cla_0109_0110 InsCheckerServer; // ( Xmi > Data > Protocols > CheckerProtocol > CheckerServer > InsCheckerServer )

    public Com_0003_0005( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsCheckerServer = new Cla_0109_0110( this, "InsCheckerServer" );
      InsCheckerServer.IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass[ 1 ];
      mClasses[ 0 ] = InsCheckerServer;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "pp_checker" :
        return InsCheckerServer.GetProvidedInterface( "Port" );
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv2 > Checker )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "pp_checker" :
        InsCheckerServer.SetRequiredInterface( "Port", oProvidedInterface );
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv2 > Checker )";
      throw new TsmException( s );
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm >> InitialState )
  public class Ini_0024_0025 : TsmPseudo
  {
    public Ini_0024_0025( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 40, "( CheckerFsm >> InitialState ) => ( CheckerFsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 40; // TRLS ( CheckerFsm >> InitialState ) => ( CheckerFsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 40: // UP: ( CheckerFsm >> InitialState ) => ( CheckerFsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm > SubFsm >> InitialState )
  public class Ini_0049_0050 : TsmPseudo
  {
    public Ini_0049_0050( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 54, "( CheckerFsm > SubFsm >> InitialState ) => ( CheckerFsm > SubFsm >> NoWait )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 54; // TRLS ( CheckerFsm > SubFsm >> InitialState ) => ( CheckerFsm > SubFsm >> NoWait )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 54: // UP: ( CheckerFsm > SubFsm >> InitialState ) => ( CheckerFsm > SubFsm >> NoWait )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm > SubFsm >> FinalState )
  public class Fin_0049_0051 : TsmFinal
  {
    public Fin_0049_0051( TsmBase oParent )
    {
      TsmName = "FinalState";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    public void Tra_0049_0055( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 55:
        Tra_0049_0055( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm > SubFsm >> NoWait )
  public class Lea_0049_0052 : TsmLeaf
  {
    public Lea_0049_0052( TsmBase oParent )
    {
      TsmName = "NoWait";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 55, "( CheckerFsm > SubFsm >> NoWait ) => ( CheckerFsm > SubFsm >> FinalState )" );
    }

    public void Tra_0049_0054( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 55; // TRLS ( CheckerFsm > SubFsm >> NoWait ) => ( CheckerFsm > SubFsm >> FinalState )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 54:
        Tra_0049_0054( oHandler );
        break;
      case 55: // UP: ( CheckerFsm > SubFsm >> NoWait ) => ( CheckerFsm > SubFsm >> FinalState )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm > SubFsm >> Again )
  public class Lea_0049_0053 : TsmLeaf
  {
    public Lea_0049_0053( TsmBase oParent )
    {
      TsmName = "Again";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 57, "( CheckerFsm > SubFsm >> Again ) => ( CheckerFsm > SubFsm > Exit1 )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 57; // TRLS ( CheckerFsm > SubFsm >> Again ) => ( CheckerFsm > SubFsm > Exit1 )
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0049_0056( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 57: // UP: ( CheckerFsm > SubFsm >> Again ) => ( CheckerFsm > SubFsm > Exit1 )
        bHigher = true;
        break;
      case 56:
        Tra_0049_0056( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm > SubFsm >)
  public class Reg_0048_0049 : TsmRegion
  {
    private Ini_0049_0050 oIni_0049_0050; // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm > SubFsm >> InitialState )
    private Fin_0049_0051 oFin_0049_0051; // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm > SubFsm >> FinalState )
    private Lea_0049_0052 oLea_0049_0052; // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm > SubFsm >> NoWait )
    private Lea_0049_0053 oLea_0049_0053; // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm > SubFsm >> Again )

    public Reg_0048_0049( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0049_0050 = new Ini_0049_0050( this );
      oFin_0049_0051 = new Fin_0049_0051( this );
      oLea_0049_0052 = new Lea_0049_0052( this );
      oLea_0049_0053 = new Lea_0049_0053( this );
      mNrStates = 4;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0049_0050;
      mStates[ 1 ] = oFin_0049_0051;
      mStates[ 2 ] = oLea_0049_0052;
      mStates[ 3 ] = oLea_0049_0053;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0049_0050.ExecuteHandler( oHandler );
    }

     // At: ( CheckerFsm > SubFsm >> InitialState ) => ( CheckerFsm > SubFsm >> NoWait )
    public void Tra_0049_0054( TsmHandler oHandler )
    {
      mCurrentState = oLea_0049_0052; // At: ( CheckerFsm > SubFsm >> NoWait )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( CheckerFsm > SubFsm >> NoWait ) => ( CheckerFsm > SubFsm >> FinalState )
    public void Tra_0049_0055( TsmHandler oHandler )
    {
      mCurrentState = oFin_0049_0051; // At: ( CheckerFsm > SubFsm >> FinalState )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // Down: ( CheckerFsm > SubFsm > Entry1 ) => ( CheckerFsm > SubFsm >> Again )
    public void Tra_0049_0056( TsmHandler oHandler )
    {
      mCurrentState = oLea_0049_0053; // Down: ( CheckerFsm > SubFsm >> Again )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 54:
        Tra_0049_0054( oHandler );
        break;
      case 55:
        Tra_0049_0055( oHandler );
        break;
      case 57: // Up: ( CheckerFsm > SubFsm >> Again ) => ( CheckerFsm > SubFsm > Exit1 )
        mCurrentState = null;
        bHigher = true;
        break;
      case 56:
        Tra_0049_0056( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm > SubFsm > Entry1 )
  public class Con_0048_0058 : TsmState
  {
    public Con_0048_0058( TsmBase oParent )
    {
      TsmName = "Entry1";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 56, "( CheckerFsm > SubFsm > Entry1 ) => ( CheckerFsm > SubFsm >> Again )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 56; // TRLS ( CheckerFsm > SubFsm > Entry1 ) => ( CheckerFsm > SubFsm >> Again )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 56: // UP: ( CheckerFsm > SubFsm > Entry1 ) => ( CheckerFsm > SubFsm >> Again )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm > SubFsm )
  public class Fsm_0023_0048 : TsmFsm
  {
    private Reg_0048_0049 oReg_0048_0049; // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm > SubFsm >)
    private Con_0048_0058 oCon_0048_0058; // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm > SubFsm > Entry1 )

    public Fsm_0023_0048( TsmBase oParent )
    {
      TsmName = "SubFsm";
      TsmParent = oParent;
      oReg_0048_0049 = new Reg_0048_0049( this );
      oCon_0048_0058 = new Con_0048_0058( this );
      mRegions.Add( oReg_0048_0049 );
      mNrTransitions = 0;
    }

    public override void Entrypoint( TsmHandler oHandler )
    {
      oReg_0048_0049.Reset();
      switch ( oHandler.Index )
      {
      case 58:
        oCon_0048_0058.Initial( oHandler );
        break;
      }
      ExecuteHandler( oHandler );
    }

    public void Tra_0049_0057( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.EXITPOINT;
      oHandler.Index  = 59; // Exit1
    }

    public void Tra_0049_0056( TsmHandler oHandler )
    {
      oReg_0048_0049.ExecuteHandler( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 57:
        Tra_0049_0057( oHandler );
        break;
      case 56:
        Tra_0049_0056( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm >> SF_1 )
  public class Sub_0024_0026 : TsmSubFsm
  {
    public Sub_0024_0026( TsmBase oParent )
    {
      TsmName = "SF_1";
      TsmParent = oParent;
      oFsm = new Fsm_0023_0048( this ); // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm > SubFsm )
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 44, "( CheckerFsm >> SF_1 ) => ( CheckerFsm >> SF_2 > ConnEntryRef )" );
    }

    public override void ExecuteTriggerless( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 44; // TRLS ( CheckerFsm >> SF_1 ) => ( CheckerFsm >> SF_2 > ConnEntryRef )
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0024_0043( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      oHandler.Action = TsmHandlerAction.ENTER;
      oFsm.ExecuteHandler( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 44: // UP: ( CheckerFsm >> SF_1 ) => ( CheckerFsm >> SF_2 > ConnEntryRef )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 43:
        Tra_0024_0043( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm >> SF_2 > ConnEntryRef )
  public class Con_0027_0028 : TsmState
  {
    public Con_0027_0028( TsmBase oParent )
    {
      TsmName = "ConnEntryRef";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm >> SF_2 > ConnExitRef )
  public class Con_0027_0029 : TsmState
  {
    public Con_0027_0029( TsmBase oParent )
    {
      TsmName = "ConnExitRef";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 45, "( CheckerFsm >> SF_2 > ConnExitRef ) => ( CheckerFsm >> Loop )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 45; // TRLS ( CheckerFsm >> SF_2 > ConnExitRef ) => ( CheckerFsm >> Loop )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 45: // UP: ( CheckerFsm >> SF_2 > ConnExitRef ) => ( CheckerFsm >> Loop )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm >> SF_2 )
  public class Sub_0024_0027 : TsmSubFsm
  {
    private Con_0027_0029 oCon_0027_0029; // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm >> SF_2 > ConnExitRef )

    public Sub_0024_0027( TsmBase oParent )
    {
      TsmName = "SF_2";
      TsmParent = oParent;
      oFsm = new Fsm_0023_0048( this ); // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm > SubFsm )
      oCon_0027_0029 = new Con_0027_0029( this );
      mNrTransitions = 0;
    }

    public void Tra_0024_0044( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      oHandler.Action = TsmHandlerAction.ENTRYPOINT;
      oHandler.Index = 58;
      oFsm.ExecuteHandler( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 44:
        Tra_0024_0044( oHandler );
        break;
      case 59: // UmlConnExit(Ref)
        oCon_0027_0029.Initial( oHandler );
        break;
      case 45: // UP: ( CheckerFsm >> SF_2 > ConnExitRef ) => ( CheckerFsm >> Loop )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm >> Composite >> InitialState )
  public class Ini_0031_0032 : TsmPseudo
  {
    public Ini_0031_0032( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 35, "( CheckerFsm >> Composite >> InitialState ) => ( CheckerFsm >> Composite >> Leaf )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 35; // TRLS ( CheckerFsm >> Composite >> InitialState ) => ( CheckerFsm >> Composite >> Leaf )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 35: // UP: ( CheckerFsm >> Composite >> InitialState ) => ( CheckerFsm >> Composite >> Leaf )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm >> Composite >> FinalState )
  public class Fin_0031_0033 : TsmFinal
  {
    public Fin_0031_0033( TsmBase oParent )
    {
      TsmName = "FinalState";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    public void Tra_0031_0036( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 36:
        Tra_0031_0036( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm >> Composite >> Leaf )
  public class Lea_0031_0034 : TsmLeaf
  {
    public Lea_0031_0034( TsmBase oParent )
    {
      TsmName = "Leaf";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 36, "( CheckerFsm >> Composite >> Leaf ) => ( CheckerFsm >> Composite >> FinalState )" );
    }

    public void Tra_0031_0035( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 36; // TRLS ( CheckerFsm >> Composite >> Leaf ) => ( CheckerFsm >> Composite >> FinalState )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 35:
        Tra_0031_0035( oHandler );
        break;
      case 36: // UP: ( CheckerFsm >> Composite >> Leaf ) => ( CheckerFsm >> Composite >> FinalState )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm >> Composite >)
  public class Reg_0030_0031 : TsmRegion
  {
    private Ini_0031_0032 oIni_0031_0032; // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm >> Composite >> InitialState )
    private Fin_0031_0033 oFin_0031_0033; // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm >> Composite >> FinalState )
    private Lea_0031_0034 oLea_0031_0034; // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm >> Composite >> Leaf )

    public Reg_0030_0031( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0031_0032 = new Ini_0031_0032( this );
      oFin_0031_0033 = new Fin_0031_0033( this );
      oLea_0031_0034 = new Lea_0031_0034( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0031_0032;
      mStates[ 1 ] = oFin_0031_0033;
      mStates[ 2 ] = oLea_0031_0034;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0031_0032.ExecuteHandler( oHandler );
    }

     // At: ( CheckerFsm >> Composite >> InitialState ) => ( CheckerFsm >> Composite >> Leaf )
    public void Tra_0031_0035( TsmHandler oHandler )
    {
      mCurrentState = oLea_0031_0034; // At: ( CheckerFsm >> Composite >> Leaf )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( CheckerFsm >> Composite >> Leaf ) => ( CheckerFsm >> Composite >> FinalState )
    public void Tra_0031_0036( TsmHandler oHandler )
    {
      mCurrentState = oFin_0031_0033; // At: ( CheckerFsm >> Composite >> FinalState )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 35:
        Tra_0031_0035( oHandler );
        break;
      case 36:
        Tra_0031_0036( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm >> Composite )
  public class Com_0024_0030 : TsmCompound
  {
    private Reg_0030_0031 oReg_0030_0031; // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm >> Composite >)

    public Com_0024_0030( TsmBase oParent )
    {
      TsmName = "Composite";
      TsmParent = oParent;
      oReg_0030_0031 = new Reg_0030_0031( this );
      mRegions.Add( oReg_0030_0031 );
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 43, "( CheckerFsm >> Composite ) => ( CheckerFsm >> SF_1 )" );
    }

    public override void ExecuteTriggerless( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 43; // TRLS ( CheckerFsm >> Composite ) => ( CheckerFsm >> SF_1 )
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0024_0047( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 43: // UP: ( CheckerFsm >> Composite ) => ( CheckerFsm >> SF_1 )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 47:
        Tra_0024_0047( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm >> Idle )
  public class Lea_0024_0037 : TsmLeaf
  {
    public Lea_0024_0037( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 41, "( CheckerFsm >> Idle ) => ( CheckerFsm >> Checking ) : pp_checker->Check" );
    }

    public void Tra_0024_0040( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0024_0042( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void pp_checker___Check( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 41; // pp_checker.Check
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 22:
        switch ( Command )
        {
        case 1:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 22: // Port pp_checker
        switch ( oHandler.Trigger.Command )
        {
        case 1: // pp_checker___Check
          {
            pp_checker___Check( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 40:
        Tra_0024_0040( oHandler );
        break;
      case 42:
        Tra_0024_0042( oHandler );
        break;
      case 41: // UP: ( CheckerFsm >> Idle ) => ( CheckerFsm >> Checking )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm >> Checking )
  public class Lea_0024_0038 : TsmLeaf
  {
    public Lea_0024_0038( TsmBase oParent )
    {
      TsmName = "Checking";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 42, "( CheckerFsm >> Checking ) => ( CheckerFsm >> Idle )" );
      mTransitions[ 1 ] = new TsmTransition( 46, "( CheckerFsm >> Checking ) => ( CheckerFsm >> Loop ) : pp_checker->Check" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 42; // TRLS ( CheckerFsm >> Checking ) => ( CheckerFsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0024_0041( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void pp_checker___Check( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 46; // pp_checker.Check
      oHandler.bTaken = true;
      mTransitions[ 1 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 22:
        switch ( Command )
        {
        case 1:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 22: // Port pp_checker
        switch ( oHandler.Trigger.Command )
        {
        case 1: // pp_checker___Check
          {
            pp_checker___Check( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 42: // UP: ( CheckerFsm >> Checking ) => ( CheckerFsm >> Idle )
        bHigher = true;
        break;
      case 41:
        Tra_0024_0041( oHandler );
        break;
      case 46: // UP: ( CheckerFsm >> Checking ) => ( CheckerFsm >> Loop )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm >> Loop )
  public class Lea_0024_0039 : TsmLeaf
  {
    public Lea_0024_0039( TsmBase oParent )
    {
      TsmName = "Loop";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 47, "( CheckerFsm >> Loop ) => ( CheckerFsm >> Composite )" );
    }

    public void Tra_0024_0045( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 47; // TRLS ( CheckerFsm >> Loop ) => ( CheckerFsm >> Composite )
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0024_0046( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 45:
        Tra_0024_0045( oHandler );
        break;
      case 47: // UP: ( CheckerFsm >> Loop ) => ( CheckerFsm >> Composite )
        bHigher = true;
        break;
      case 46:
        Tra_0024_0046( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm >)
  public class Reg_0023_0024 : TsmRegion
  {
    private Ini_0024_0025 oIni_0024_0025; // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm >> InitialState )
    private Sub_0024_0026 oSub_0024_0026; // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm >> SF_1 )
    private Sub_0024_0027 oSub_0024_0027; // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm >> SF_2 )
    private Com_0024_0030 oCom_0024_0030; // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm >> Composite )
    private Lea_0024_0037 oLea_0024_0037; // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm >> Idle )
    private Lea_0024_0038 oLea_0024_0038; // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm >> Checking )
    private Lea_0024_0039 oLea_0024_0039; // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm >> Loop )

    public Reg_0023_0024( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0024_0025 = new Ini_0024_0025( this );
      oSub_0024_0026 = new Sub_0024_0026( this );
      oSub_0024_0027 = new Sub_0024_0027( this );
      oCom_0024_0030 = new Com_0024_0030( this );
      oLea_0024_0037 = new Lea_0024_0037( this );
      oLea_0024_0038 = new Lea_0024_0038( this );
      oLea_0024_0039 = new Lea_0024_0039( this );
      mNrStates = 7;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0024_0025;
      mStates[ 1 ] = oSub_0024_0026;
      mStates[ 2 ] = oSub_0024_0027;
      mStates[ 3 ] = oCom_0024_0030;
      mStates[ 4 ] = oLea_0024_0037;
      mStates[ 5 ] = oLea_0024_0038;
      mStates[ 6 ] = oLea_0024_0039;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0024_0025.ExecuteHandler( oHandler );
    }

     // At: ( CheckerFsm >> InitialState ) => ( CheckerFsm >> Idle )
    public void Tra_0024_0040( TsmHandler oHandler )
    {
      mCurrentState = oLea_0024_0037; // At: ( CheckerFsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( CheckerFsm >> SF_1 ) => ( CheckerFsm >> SF_2 > ConnEntryRef )
    public void Tra_0024_0044( TsmHandler oHandler )
    {
      mCurrentState = oSub_0024_0027; // At: ( CheckerFsm >> SF_2 )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( CheckerFsm >> SF_2 > ConnExitRef ) => ( CheckerFsm >> Loop )
    public void Tra_0024_0045( TsmHandler oHandler )
    {
      mCurrentState = oLea_0024_0039; // At: ( CheckerFsm >> Loop )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( CheckerFsm >> Composite ) => ( CheckerFsm >> SF_1 )
    public void Tra_0024_0043( TsmHandler oHandler )
    {
      mCurrentState = oSub_0024_0026; // At: ( CheckerFsm >> SF_1 )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( CheckerFsm >> Checking ) => ( CheckerFsm >> Idle )
    public void Tra_0024_0042( TsmHandler oHandler )
    {
      ((Cla_0019_0021)oHandler.Owner).Function_1001( oHandler );
      mCurrentState = oLea_0024_0037; // At: ( CheckerFsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( CheckerFsm >> Loop ) => ( CheckerFsm >> Composite )
    public void Tra_0024_0047( TsmHandler oHandler )
    {
      mCurrentState = oCom_0024_0030; // At: ( CheckerFsm >> Composite )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( CheckerFsm >> Idle ) => ( CheckerFsm >> Checking )
    public void Tra_0024_0041( TsmHandler oHandler )
    {
      mCurrentState = oLea_0024_0038; // At: ( CheckerFsm >> Checking )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( CheckerFsm >> Checking ) => ( CheckerFsm >> Loop )
    public void Tra_0024_0046( TsmHandler oHandler )
    {
      mCurrentState = oLea_0024_0039; // At: ( CheckerFsm >> Loop )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 22:
        switch ( Command )
        {
        case 1:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 40:
        Tra_0024_0040( oHandler );
        break;
      case 44:
        Tra_0024_0044( oHandler );
        break;
      case 45:
        Tra_0024_0045( oHandler );
        break;
      case 43:
        Tra_0024_0043( oHandler );
        break;
      case 42:
        Tra_0024_0042( oHandler );
        break;
      case 47:
        Tra_0024_0047( oHandler );
        break;
      case 41:
        Tra_0024_0041( oHandler );
        break;
      case 46:
        Tra_0024_0046( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm )
  public class Fsm_0021_0023 : TsmFsm
  {
    private Reg_0023_0024 oReg_0023_0024; // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm >)

    public Fsm_0021_0023( TsmBase oParent )
    {
      TsmName = "CheckerFsm";
      TsmParent = oParent;
      oReg_0023_0024 = new Reg_0023_0024( this );
      mRegions.Add( oReg_0023_0024 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass )
  public class Cla_0019_0021 : TsmClass
  {
    private Fsm_0021_0023 oFsm_0021_0023; // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > CheckerFsm )
    private TsmIPort_IChecker TsmPI__pp_checker; // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > pp_checker )
    private TsmIPort_ICbChecker pp_checker; // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass > pp_checker )
    private TsmPSPort mPSMessager;

    public Cla_0019_0021( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0021_0023 = new Fsm_0021_0023( this );
      TsmPI__pp_checker = new TsmIPort_IChecker( this );
      mPSMessager = new TsmPSPort();
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0021_0023;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "pp_checker" :
        return TsmPI__pp_checker;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "pp_checker" :
        pp_checker = (TsmIPort_ICbChecker) oProvidedInterface;
        pp_checker.Source = this;
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > CheckerClass )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0021_0023.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

     // ( CheckerFsm >> Checking ) => ( CheckerFsm >> Idle )
    public void Function_1001( TsmHandler oHandler )
    {
      pp_checker.CbChecked();
    }

    public override void TsmInitialise( object oObject )
    {
      TsmPI__pp_checker.PortId = 22;
      TsmPI__pp_checker.Messager = mPSMessager;
    }

    public override void TsmConnect( object oObject )
    {
      mPSMessager.Target = this;
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0021_0023.ExecuteHandler( lHandler );
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent )
  public class Com_0018_0019 : TsmLComponent
  {
    private Cla_0019_0021 Checker; // ( Xmi > Data > Repository > HowlersPackage > CheckerComponent > Checker )

    public Com_0018_0019( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      Checker = new Cla_0019_0021( this, "Checker" );
      mNrClasses = 1;
      mClasses = new TsmClass[ 1 ];
      mClasses[ 0 ] = Checker;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "d_pp_checker" :
        return Checker.GetProvidedInterface( "pp_checker" );
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > HowlersPackage > CheckerComponent )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "d_pp_checker" :
        Checker.SetRequiredInterface( "pp_checker", oProvidedInterface );
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > HowlersPackage > CheckerComponent )";
      throw new TsmException( s );
    }
  }

   // ( Xmi > Data > Repository > HowlersPackage > System1 )
  public class Com_0018_0060 : TsmAComponent
  {
    private Com_0018_0063 Howlers; // ( Xmi > Data > Repository > HowlersPackage > System1 > Howlers )
    private Com_0018_0019 Checker; // ( Xmi > Data > Repository > HowlersPackage > System1 > Checker )
    private TsmIPort_IHowlers TsmPI__pp_howlers; // ( Xmi > Data > Repository > HowlersPackage > System1 > pp_howlers )
    private TsmASPort TsmMr__pp_howlers;
    private TsmIPort_ICbSlave TsmPI__rp_slave; // ( Xmi > Data > Repository > HowlersPackage > System1 > rp_slave )
    private TsmACPort TsmMr__rp_slave;

    public Com_0018_0060( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      Howlers = new Com_0018_0063( this, "Howlers" );
      Checker = new Com_0018_0019( this, "Checker" );
      mNrComponents = 2;
      mComponents = new TsmComponent[ 2 ];
      mComponents[ 0 ] = Howlers;
      mComponents[ 1 ] = Checker;
      TsmPI__pp_howlers = new TsmIPort_IHowlers( this );
      TsmMr__pp_howlers = new TsmASPort();
      TsmPI__rp_slave = new TsmIPort_ICbSlave( this );
      TsmMr__rp_slave = new TsmACPort();
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "pp_howlers" :
        return TsmPI__pp_howlers;
      case "rp_slave" :
        return TsmPI__rp_slave;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > HowlersPackage > System1 )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "pp_howlers" :
        Howlers.SetRequiredInterface( "d_pp_howlers", oProvidedInterface );
        return;
      case "rp_slave" :
        Howlers.SetRequiredInterface( "d_rp_slave", oProvidedInterface );
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > HowlersPackage > System1 )";
      throw new TsmException( s );
    }

    public override void TsmInitialise( object oObject )
    {
      base.TsmInitialise( oObject );
      TsmMr__pp_howlers.Thread = Thread;
      TsmPI__pp_howlers.Messager = TsmMr__pp_howlers;
      TsmMr__rp_slave.Thread = Thread;
      TsmPI__rp_slave.Messager = TsmMr__rp_slave;
    }

    public override void TsmConnect( object oObject )
    {
      TsmInterfacePort ClassPort;
      ClassPort = Howlers.GetProvidedInterface( "d_pp_howlers" );
      TsmPI__pp_howlers.PortId = ClassPort.PortId;
      TsmMr__pp_howlers.Target = ClassPort.Messager.Target;
      ClassPort = Howlers.GetProvidedInterface( "d_rp_slave" );
      TsmPI__rp_slave.PortId = ClassPort.PortId;
      TsmMr__rp_slave.Target = ClassPort.Messager.Target;
      DoAssembly( Howlers, "d_rp_checker", Checker, "d_pp_checker" );
      DoAssembly( Checker, "d_pp_checker", Howlers, "d_rp_checker" );
    }
  }

   // ( Xmi > Data > Architecture > ExecEnv1 > Ui )
  public class Com_0008_0007 : TsmPComponent
  {
    private Cla_0161_0162 InsHowlersClient; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersClient > InsHowlersClient )

    public Com_0008_0007( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsHowlersClient = new Cla_0161_0162( this, "InsHowlersClient" );
      InsHowlersClient.IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass[ 1 ];
      mClasses[ 0 ] = InsHowlersClient;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "rp_howlers" :
        return InsHowlersClient.GetProvidedInterface( "Port" );
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv1 > Ui )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "rp_howlers" :
        InsHowlersClient.SetRequiredInterface( "Port", oProvidedInterface );
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv1 > Ui )";
      throw new TsmException( s );
    }
  }

   // ( Xmi > Data > Architecture > ExecEnv1 > Slave )
  public class Com_0008_0009 : TsmPComponent
  {
    private Cla_0130_0146 InsSlaveServer; // ( Xmi > Data > Protocols > SlaveProtocol > SlaveServer > InsSlaveServer )

    public Com_0008_0009( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      InsSlaveServer = new Cla_0130_0146( this, "InsSlaveServer" );
      InsSlaveServer.IsMock = true;
      mNrClasses = 1;
      mClasses = new TsmClass[ 1 ];
      mClasses[ 0 ] = InsSlaveServer;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "pp_slave" :
        return InsSlaveServer.GetProvidedInterface( "Port" );
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv1 > Slave )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "pp_slave" :
        InsSlaveServer.SetRequiredInterface( "Port", oProvidedInterface );
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExecEnv1 > Slave )";
      throw new TsmException( s );
    }
  }

   // ( Xmi > Data > Architecture > ExecEnv1 )
  public class Com_0002_0008 : TsmPComponent
  {
    private Com_0018_0060 MySystem1; // ( Xmi > Data > Architecture > ExecEnv1 > MySystem1 )
    private Com_0008_0007 Ui; // ( Xmi > Data > Architecture > ExecEnv1 > Ui )
    private Com_0008_0009 Slave; // ( Xmi > Data > Architecture > ExecEnv1 > Slave )

    public Com_0002_0008( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      MySystem1 = new Com_0018_0060( this, "MySystem1" );
      Ui = new Com_0008_0007( this, "Ui" );
      Slave = new Com_0008_0009( this, "Slave" );
      mNrComponents = 3;
      mComponents = new TsmComponent[ 3 ];
      mComponents[ 0 ] = MySystem1;
      mComponents[ 1 ] = Ui;
      mComponents[ 2 ] = Slave;
    }

    public override void TsmConnect( object oObject )
    {
      DoAssembly( Ui, "rp_howlers", MySystem1, "pp_howlers" );
      DoAssembly( MySystem1, "pp_howlers", Ui, "rp_howlers" );
      DoAssembly( MySystem1, "rp_slave", Slave, "pp_slave" );
      DoAssembly( Slave, "pp_slave", MySystem1, "rp_slave" );
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Architecture > Sequence Diagrams )
   ********************************************************************/

   // ( Xmi > Data > Architecture > Sequence Diagrams )
  public class Pac_0002_0012 : TsmPackage
  {
    public Pac_0002_0012( TsmBase oParent )
    {
      TsmName = "Sequence Diagrams";
      TsmParent = oParent;
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Architecture )
   ********************************************************************/

   // ( Xmi > Data > Architecture )
  public class Pac_0001_0002 : TsmPackage
  {
    public Pac_0001_0002( TsmBase oParent )
    {
      TsmName = "Architecture";
      TsmParent = oParent;
    }
  }

   // ( Xmi > Data > Repository > Terminators > CheckerMock )
  public class Com_0014_0015 : TsmPComponent
  {
    public Com_0014_0015( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
    }
  }

   // ( Xmi > Data > Repository > Terminators > UiComponent )
  public class Com_0014_0016 : TsmPComponent
  {
    public Com_0014_0016( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
    }
  }

   // ( Xmi > Data > Repository > Terminators > SlaveComponent )
  public class Com_0014_0017 : TsmPComponent
  {
    public Com_0014_0017( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository > Terminators )
   ********************************************************************/

   // ( Xmi > Data > Repository > Terminators )
  public class Pac_0013_0014 : TsmPackage
  {
    public Pac_0013_0014( TsmBase oParent )
    {
      TsmName = "Terminators";
      TsmParent = oParent;
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository > HowlersPackage )
   ********************************************************************/

   // ( Xmi > Data > Repository > HowlersPackage )
  public class Pac_0013_0018 : TsmPackage
  {
    public Pac_0013_0018( TsmBase oParent )
    {
      TsmName = "HowlersPackage";
      TsmParent = oParent;
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Repository )
   ********************************************************************/

   // ( Xmi > Data > Repository )
  public class Pac_0001_0013 : TsmPackage
  {
    public Pac_0001_0013( TsmBase oParent )
    {
      TsmName = "Repository";
      TsmParent = oParent;
    }
  }

  public interface ICbChecker
  {
    void CbChecked();
  }

  public class TsmTrigger_ICbChecker___CbChecked : TsmTrigger
  {
    public TsmTrigger_ICbChecker___CbChecked()
      : base( 11 )
    {
    }
  }

   // ( Xmi > Data > Protocols > CheckerProtocol > ICbChecker )
  public class TsmIPort_ICbChecker : TsmInterfacePort, ICbChecker
  {
    public TsmIPort_ICbChecker( TsmBase oParent )
    {
      TsmName = "ICbChecker";
      TsmParent = oParent;
    }

    public virtual void CbChecked()
    {
      TsmTrigger_ICbChecker___CbChecked tt = new TsmTrigger_ICbChecker___CbChecked();
      TsmRecorder.AddCall( "CbChecked", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }
  }

  public interface IChecker
  {
    void Check();
  }

  public class TsmTrigger_IChecker___Check : TsmTrigger
  {
    public TsmTrigger_IChecker___Check()
      : base( 1 )
    {
    }
  }

   // ( Xmi > Data > Protocols > CheckerProtocol > IChecker )
  public class TsmIPort_IChecker : TsmInterfacePort, IChecker
  {
    public TsmIPort_IChecker( TsmBase oParent )
    {
      TsmName = "IChecker";
      TsmParent = oParent;
    }

    public virtual void Check()
    {
      TsmTrigger_IChecker___Check tt = new TsmTrigger_IChecker___Check();
      TsmRecorder.AddCall( "Check", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }
  }

   // ( Xmi > Data > Protocols > CheckerProtocol > CheckerClient > CheckerClientPsm >> InitialState )
  public class Ini_0123_0124 : TsmPseudo
  {
    public Ini_0123_0124( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 127, "( CheckerClientPsm >> InitialState ) => ( CheckerClientPsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 127; // TRLS ( CheckerClientPsm >> InitialState ) => ( CheckerClientPsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 127: // UP: ( CheckerClientPsm >> InitialState ) => ( CheckerClientPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > CheckerProtocol > CheckerClient > CheckerClientPsm >> Idle )
  public class Lea_0123_0125 : TsmLeaf
  {
    int [] aNatives = { -128 };

    public Lea_0123_0125( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 128, "( CheckerClientPsm >> Idle ) => ( CheckerClientPsm >> Checking )" );
    }

    public void Tra_0123_0127( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0123_0129( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 128:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 128: // Native: ( CheckerClientPsm >> Idle ) => ( CheckerClientPsm >> Checking )
          TsmRecorder.AddNative( "( CheckerClientPsm >> Idle ) => ( CheckerClientPsm >> Checking ) # Check();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 128;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 127:
        Tra_0123_0127( oHandler );
        break;
      case 128: // UP: ( CheckerClientPsm >> Idle ) => ( CheckerClientPsm >> Checking )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 129:
        Tra_0123_0129( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > CheckerProtocol > CheckerClient > CheckerClientPsm >> Checking )
  public class Lea_0123_0126 : TsmLeaf
  {
    public Lea_0123_0126( TsmBase oParent )
    {
      TsmName = "Checking";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 129, "( CheckerClientPsm >> Checking ) => ( CheckerClientPsm >> Idle ) : CbChecked" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0123_0128( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Port___CbChecked( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 129; // CbChecked
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 121:
        switch ( Command )
        {
        case 11:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 121: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 11: // Port___CbChecked
          {
            Port___CbChecked( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 128:
        Tra_0123_0128( oHandler );
        break;
      case 129: // UP: ( CheckerClientPsm >> Checking ) => ( CheckerClientPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > CheckerProtocol > CheckerClient > CheckerClientPsm >)
  public class Reg_0122_0123 : TsmRegion
  {
    private Ini_0123_0124 oIni_0123_0124; // ( Xmi > Data > Protocols > CheckerProtocol > CheckerClient > CheckerClientPsm >> InitialState )
    private Lea_0123_0125 oLea_0123_0125; // ( Xmi > Data > Protocols > CheckerProtocol > CheckerClient > CheckerClientPsm >> Idle )
    private Lea_0123_0126 oLea_0123_0126; // ( Xmi > Data > Protocols > CheckerProtocol > CheckerClient > CheckerClientPsm >> Checking )

    public Reg_0122_0123( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0123_0124 = new Ini_0123_0124( this );
      oLea_0123_0125 = new Lea_0123_0125( this );
      oLea_0123_0126 = new Lea_0123_0126( this );
      mNrStates = 3;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0123_0124;
      mStates[ 1 ] = oLea_0123_0125;
      mStates[ 2 ] = oLea_0123_0126;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0123_0124.ExecuteHandler( oHandler );
    }

     // At: ( CheckerClientPsm >> InitialState ) => ( CheckerClientPsm >> Idle )
    public void Tra_0123_0127( TsmHandler oHandler )
    {
      mCurrentState = oLea_0123_0125; // At: ( CheckerClientPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( CheckerClientPsm >> Idle ) => ( CheckerClientPsm >> Checking )
    public void Tra_0123_0128( TsmHandler oHandler )
    {
      ((Cla_0109_0120)oHandler.Owner).Function_1006( oHandler );
      mCurrentState = oLea_0123_0126; // At: ( CheckerClientPsm >> Checking )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( CheckerClientPsm >> Checking ) => ( CheckerClientPsm >> Idle )
    public void Tra_0123_0129( TsmHandler oHandler )
    {
      mCurrentState = oLea_0123_0125; // At: ( CheckerClientPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 128:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port -1
      case 121:
        switch ( Command )
        {
        case 11:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 127:
        Tra_0123_0127( oHandler );
        break;
      case 128:
        Tra_0123_0128( oHandler );
        break;
      case 129:
        Tra_0123_0129( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > CheckerProtocol > CheckerClient > CheckerClientPsm )
  public class Fsm_0120_0122 : TsmFsm
  {
    private Reg_0122_0123 oReg_0122_0123; // ( Xmi > Data > Protocols > CheckerProtocol > CheckerClient > CheckerClientPsm >)

    public Fsm_0120_0122( TsmBase oParent )
    {
      TsmName = "CheckerClientPsm";
      TsmParent = oParent;
      oReg_0122_0123 = new Reg_0122_0123( this );
      mRegions.Add( oReg_0122_0123 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Protocols > CheckerProtocol > CheckerClient )
  public class Cla_0109_0120 : TsmProtocolClass
  {
    private Fsm_0120_0122 oFsm_0120_0122; // ( Xmi > Data > Protocols > CheckerProtocol > CheckerClient > CheckerClientPsm )
    private TsmIPort_IChecker Port; // ( Xmi > Data > Protocols > CheckerProtocol > CheckerClient > Port )
    private TsmIPort_ICbChecker TsmPI__Port; // ( Xmi > Data > Protocols > CheckerProtocol > CheckerClient > Port )
    private TsmPCPort mPCMessager;

    public Cla_0109_0120( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0120_0122 = new Fsm_0120_0122( this );
      TsmPI__Port = new TsmIPort_ICbChecker( this );
      mPCMessager = new TsmPCPort();
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0120_0122;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "Port" :
        return TsmPI__Port;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > CheckerProtocol > CheckerClient )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "Port" :
        Port = (TsmIPort_IChecker) oProvidedInterface;
        Port.Source = this;
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > CheckerProtocol > CheckerClient )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0120_0122.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

     // ( CheckerClientPsm >> Idle ) => ( CheckerClientPsm >> Checking )
    public void Function_1006( TsmHandler oHandler )
    {
      Port.Check();
    }

    public override void TsmInitialise( object oObject )
    {
      TsmPI__Port.PortId = 121;
      TsmPI__Port.Messager = mPCMessager;
    }

    public override void TsmConnect( object oObject )
    {
      mPCMessager.Target = this;
      mPCMessager.IntQueue = (TsmIntQueue) oObject;
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0120_0122.ExecuteHandler( lHandler );
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols > CheckerProtocol )
   ********************************************************************/

   // ( Xmi > Data > Protocols > CheckerProtocol )
  public class Pac_0108_0109 : TsmPackage
  {
    public Pac_0108_0109( TsmBase oParent )
    {
      TsmName = "CheckerProtocol";
      TsmParent = oParent;
    }
  }

  public interface ICbSlave
  {
    void CbOutSync();
    void CbStarted();
    void CbStopped();
  }

  public class TsmTrigger_ICbSlave___CbOutSync : TsmTrigger
  {
    public TsmTrigger_ICbSlave___CbOutSync()
      : base( 8 )
    {
    }
  }

  public class TsmTrigger_ICbSlave___CbStarted : TsmTrigger
  {
    public TsmTrigger_ICbSlave___CbStarted()
      : base( 9 )
    {
    }
  }

  public class TsmTrigger_ICbSlave___CbStopped : TsmTrigger
  {
    public TsmTrigger_ICbSlave___CbStopped()
      : base( 10 )
    {
    }
  }

   // ( Xmi > Data > Protocols > SlaveProtocol > ICbSlave )
  public class TsmIPort_ICbSlave : TsmInterfacePort, ICbSlave
  {
    public TsmIPort_ICbSlave( TsmBase oParent )
    {
      TsmName = "ICbSlave";
      TsmParent = oParent;
    }

    public virtual void CbOutSync()
    {
      TsmTrigger_ICbSlave___CbOutSync tt = new TsmTrigger_ICbSlave___CbOutSync();
      TsmRecorder.AddCall( "CbOutSync", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }

    public virtual void CbStarted()
    {
      TsmTrigger_ICbSlave___CbStarted tt = new TsmTrigger_ICbSlave___CbStarted();
      TsmRecorder.AddCall( "CbStarted", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }

    public virtual void CbStopped()
    {
      TsmTrigger_ICbSlave___CbStopped tt = new TsmTrigger_ICbSlave___CbStopped();
      TsmRecorder.AddCall( "CbStopped", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }
  }

  public interface ISlave
  {
    void Start();
    void Stop();
  }

  public class TsmTrigger_ISlave___Start : TsmTrigger
  {
    public TsmTrigger_ISlave___Start()
      : base( 12 )
    {
    }
  }

  public class TsmTrigger_ISlave___Stop : TsmTrigger
  {
    public TsmTrigger_ISlave___Stop()
      : base( 13 )
    {
    }
  }

   // ( Xmi > Data > Protocols > SlaveProtocol > ISlave )
  public class TsmIPort_ISlave : TsmInterfacePort, ISlave
  {
    public TsmIPort_ISlave( TsmBase oParent )
    {
      TsmName = "ISlave";
      TsmParent = oParent;
    }

    public virtual void Start()
    {
      TsmTrigger_ISlave___Start tt = new TsmTrigger_ISlave___Start();
      TsmRecorder.AddCall( "Start", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }

    public virtual void Stop()
    {
      TsmTrigger_ISlave___Stop tt = new TsmTrigger_ISlave___Stop();
      TsmRecorder.AddCall( "Stop", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }
  }

   // ( Xmi > Data > Protocols > SlaveProtocol > SlaveClient > SlaveClientPsm >> InitialState )
  public class Ini_0134_0135 : TsmPseudo
  {
    public Ini_0134_0135( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 140, "( SlaveClientPsm >> InitialState ) => ( SlaveClientPsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 140; // TRLS ( SlaveClientPsm >> InitialState ) => ( SlaveClientPsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 140: // UP: ( SlaveClientPsm >> InitialState ) => ( SlaveClientPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SlaveProtocol > SlaveClient > SlaveClientPsm >> Idle )
  public class Lea_0134_0136 : TsmLeaf
  {
    int [] aNatives = { -143 };

    public Lea_0134_0136( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 143, "( SlaveClientPsm >> Idle ) => ( SlaveClientPsm >> Starting )" );
    }

    public void Tra_0134_0140( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0134_0145( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 143:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 143: // Native: ( SlaveClientPsm >> Idle ) => ( SlaveClientPsm >> Starting )
          TsmRecorder.AddNative( "( SlaveClientPsm >> Idle ) => ( SlaveClientPsm >> Starting ) # Start();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 143;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 140:
        Tra_0134_0140( oHandler );
        break;
      case 143: // UP: ( SlaveClientPsm >> Idle ) => ( SlaveClientPsm >> Starting )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 145:
        Tra_0134_0145( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SlaveProtocol > SlaveClient > SlaveClientPsm >> Starting )
  public class Lea_0134_0137 : TsmLeaf
  {
    public Lea_0134_0137( TsmBase oParent )
    {
      TsmName = "Starting";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 142, "( SlaveClientPsm >> Starting ) => ( SlaveClientPsm >> Busy ) : CbStarted" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0134_0143( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Port___CbStarted( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 142; // CbStarted
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 132:
        switch ( Command )
        {
        case 9:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 132: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 9: // Port___CbStarted
          {
            Port___CbStarted( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 143:
        Tra_0134_0143( oHandler );
        break;
      case 142: // UP: ( SlaveClientPsm >> Starting ) => ( SlaveClientPsm >> Busy )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SlaveProtocol > SlaveClient > SlaveClientPsm >> Busy )
  public class Lea_0134_0138 : TsmLeaf
  {
    int [] aNatives = { -144 };

    public Lea_0134_0138( TsmBase oParent )
    {
      TsmName = "Busy";
      TsmParent = oParent;
      mNrTransitions = 2;
      mTransitions = new TsmTransition[ 2 ];
      mTransitions[ 0 ] = new TsmTransition( 144, "( SlaveClientPsm >> Busy ) => ( SlaveClientPsm >> Stopping )" );
      mTransitions[ 1 ] = new TsmTransition( 141, "( SlaveClientPsm >> Busy ) => ( SlaveClientPsm >> Busy ) : CbOutSync" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0134_0141( TsmHandler oHandler )
    {
      AtExit( oHandler );
      AtEntry( oHandler );
      oHandler.bTaken = true;
      oHandler.Action = TsmHandlerAction.INITIAL;
    }

    public void Port___CbOutSync( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 141; // CbOutSync
      oHandler.bTaken = true;
      mTransitions[ 1 ].bVisit = true;
    }

    public void Tra_0134_0142( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 144:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port -1
      case 132:
        switch ( Command )
        {
        case 8:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 144: // Native: ( SlaveClientPsm >> Busy ) => ( SlaveClientPsm >> Stopping )
          TsmRecorder.AddNative( "( SlaveClientPsm >> Busy ) => ( SlaveClientPsm >> Stopping ) # Stop();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 144;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break; // end of Port -1
      case 132: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 8: // Port___CbOutSync
          {
            Port___CbOutSync( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 144: // UP: ( SlaveClientPsm >> Busy ) => ( SlaveClientPsm >> Stopping )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 141:
        Tra_0134_0141( oHandler );
        break;
      case 142:
        Tra_0134_0142( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SlaveProtocol > SlaveClient > SlaveClientPsm >> Stopping )
  public class Lea_0134_0139 : TsmLeaf
  {
    public Lea_0134_0139( TsmBase oParent )
    {
      TsmName = "Stopping";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 145, "( SlaveClientPsm >> Stopping ) => ( SlaveClientPsm >> Idle ) : CbStopped" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0134_0144( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Port___CbStopped( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 145; // CbStopped
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 132:
        switch ( Command )
        {
        case 10:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 132: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 10: // Port___CbStopped
          {
            Port___CbStopped( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 144:
        Tra_0134_0144( oHandler );
        break;
      case 145: // UP: ( SlaveClientPsm >> Stopping ) => ( SlaveClientPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SlaveProtocol > SlaveClient > SlaveClientPsm >)
  public class Reg_0133_0134 : TsmRegion
  {
    private Ini_0134_0135 oIni_0134_0135; // ( Xmi > Data > Protocols > SlaveProtocol > SlaveClient > SlaveClientPsm >> InitialState )
    private Lea_0134_0136 oLea_0134_0136; // ( Xmi > Data > Protocols > SlaveProtocol > SlaveClient > SlaveClientPsm >> Idle )
    private Lea_0134_0137 oLea_0134_0137; // ( Xmi > Data > Protocols > SlaveProtocol > SlaveClient > SlaveClientPsm >> Starting )
    private Lea_0134_0138 oLea_0134_0138; // ( Xmi > Data > Protocols > SlaveProtocol > SlaveClient > SlaveClientPsm >> Busy )
    private Lea_0134_0139 oLea_0134_0139; // ( Xmi > Data > Protocols > SlaveProtocol > SlaveClient > SlaveClientPsm >> Stopping )

    public Reg_0133_0134( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0134_0135 = new Ini_0134_0135( this );
      oLea_0134_0136 = new Lea_0134_0136( this );
      oLea_0134_0137 = new Lea_0134_0137( this );
      oLea_0134_0138 = new Lea_0134_0138( this );
      oLea_0134_0139 = new Lea_0134_0139( this );
      mNrStates = 5;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0134_0135;
      mStates[ 1 ] = oLea_0134_0136;
      mStates[ 2 ] = oLea_0134_0137;
      mStates[ 3 ] = oLea_0134_0138;
      mStates[ 4 ] = oLea_0134_0139;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0134_0135.ExecuteHandler( oHandler );
    }

     // At: ( SlaveClientPsm >> InitialState ) => ( SlaveClientPsm >> Idle )
    public void Tra_0134_0140( TsmHandler oHandler )
    {
      mCurrentState = oLea_0134_0136; // At: ( SlaveClientPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( SlaveClientPsm >> Idle ) => ( SlaveClientPsm >> Starting )
    public void Tra_0134_0143( TsmHandler oHandler )
    {
      ((Cla_0130_0131)oHandler.Owner).Function_1007( oHandler );
      mCurrentState = oLea_0134_0137; // At: ( SlaveClientPsm >> Starting )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( SlaveClientPsm >> Busy ) => ( SlaveClientPsm >> Stopping )
    public void Tra_0134_0144( TsmHandler oHandler )
    {
      ((Cla_0130_0131)oHandler.Owner).Function_1008( oHandler );
      mCurrentState = oLea_0134_0139; // At: ( SlaveClientPsm >> Stopping )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( SlaveClientPsm >> Starting ) => ( SlaveClientPsm >> Busy )
    public void Tra_0134_0142( TsmHandler oHandler )
    {
      mCurrentState = oLea_0134_0138; // At: ( SlaveClientPsm >> Busy )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( SlaveClientPsm >> Stopping ) => ( SlaveClientPsm >> Idle )
    public void Tra_0134_0145( TsmHandler oHandler )
    {
      mCurrentState = oLea_0134_0136; // At: ( SlaveClientPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 143:
          return TsmProspect.OK;
        case 144:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port -1
      case 132:
        switch ( Command )
        {
        case 8:
          return TsmProspect.OK;
        case 9:
          return TsmProspect.OK;
        case 10:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 140:
        Tra_0134_0140( oHandler );
        break;
      case 143:
        Tra_0134_0143( oHandler );
        break;
      case 144:
        Tra_0134_0144( oHandler );
        break;
      case 142:
        Tra_0134_0142( oHandler );
        break;
      case 145:
        Tra_0134_0145( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > SlaveProtocol > SlaveClient > SlaveClientPsm )
  public class Fsm_0131_0133 : TsmFsm
  {
    private Reg_0133_0134 oReg_0133_0134; // ( Xmi > Data > Protocols > SlaveProtocol > SlaveClient > SlaveClientPsm >)

    public Fsm_0131_0133( TsmBase oParent )
    {
      TsmName = "SlaveClientPsm";
      TsmParent = oParent;
      oReg_0133_0134 = new Reg_0133_0134( this );
      mRegions.Add( oReg_0133_0134 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Protocols > SlaveProtocol > SlaveClient )
  public class Cla_0130_0131 : TsmProtocolClass
  {
    private Fsm_0131_0133 oFsm_0131_0133; // ( Xmi > Data > Protocols > SlaveProtocol > SlaveClient > SlaveClientPsm )
    private TsmIPort_ISlave Port; // ( Xmi > Data > Protocols > SlaveProtocol > SlaveClient > Port )
    private TsmIPort_ICbSlave TsmPI__Port; // ( Xmi > Data > Protocols > SlaveProtocol > SlaveClient > Port )
    private TsmPCPort mPCMessager;

    public Cla_0130_0131( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0131_0133 = new Fsm_0131_0133( this );
      TsmPI__Port = new TsmIPort_ICbSlave( this );
      mPCMessager = new TsmPCPort();
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0131_0133;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "Port" :
        return TsmPI__Port;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > SlaveProtocol > SlaveClient )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "Port" :
        Port = (TsmIPort_ISlave) oProvidedInterface;
        Port.Source = this;
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > SlaveProtocol > SlaveClient )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0131_0133.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

     // ( SlaveClientPsm >> Idle ) => ( SlaveClientPsm >> Starting )
    public void Function_1007( TsmHandler oHandler )
    {
      Port.Start();
    }

     // ( SlaveClientPsm >> Busy ) => ( SlaveClientPsm >> Stopping )
    public void Function_1008( TsmHandler oHandler )
    {
      Port.Stop();
    }

    public override void TsmInitialise( object oObject )
    {
      TsmPI__Port.PortId = 132;
      TsmPI__Port.Messager = mPCMessager;
    }

    public override void TsmConnect( object oObject )
    {
      mPCMessager.Target = this;
      mPCMessager.IntQueue = (TsmIntQueue) oObject;
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0131_0133.ExecuteHandler( lHandler );
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols > SlaveProtocol )
   ********************************************************************/

   // ( Xmi > Data > Protocols > SlaveProtocol )
  public class Pac_0108_0130 : TsmPackage
  {
    public Pac_0108_0130( TsmBase oParent )
    {
      TsmName = "SlaveProtocol";
      TsmParent = oParent;
    }
  }

  public interface IHowlers
  {
    int GetInfo();
    void Pause();
    void Slow();
    void Start();
    void Stop();
    void Test();
  }

  public class TsmTrigger_IHowlers___GetInfo : TsmTrigger
  {
    public int _RetVal;

    public TsmTrigger_IHowlers___GetInfo()
      : base( 2 )
    {
    }
  }

  public class TsmTrigger_IHowlers___Pause : TsmTrigger
  {
    public TsmTrigger_IHowlers___Pause()
      : base( 3 )
    {
    }
  }

  public class TsmTrigger_IHowlers___Slow : TsmTrigger
  {
    public TsmTrigger_IHowlers___Slow()
      : base( 4 )
    {
    }
  }

  public class TsmTrigger_IHowlers___Start : TsmTrigger
  {
    public TsmTrigger_IHowlers___Start()
      : base( 5 )
    {
    }
  }

  public class TsmTrigger_IHowlers___Stop : TsmTrigger
  {
    public TsmTrigger_IHowlers___Stop()
      : base( 6 )
    {
    }
  }

  public class TsmTrigger_IHowlers___Test : TsmTrigger
  {
    public TsmTrigger_IHowlers___Test()
      : base( 7 )
    {
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > IHowlers )
  public class TsmIPort_IHowlers : TsmInterfacePort, IHowlers
  {
    public TsmIPort_IHowlers( TsmBase oParent )
    {
      TsmName = "IHowlers";
      TsmParent = oParent;
    }

    public virtual int GetInfo()
    {
      TsmTrigger_IHowlers___GetInfo tt = new TsmTrigger_IHowlers___GetInfo();
      TsmRecorder.AddCall( "GetInfo", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
      return tt._RetVal;
    }

    public virtual void Pause()
    {
      TsmTrigger_IHowlers___Pause tt = new TsmTrigger_IHowlers___Pause();
      TsmRecorder.AddCall( "Pause", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }

    public virtual void Slow()
    {
      TsmTrigger_IHowlers___Slow tt = new TsmTrigger_IHowlers___Slow();
      TsmRecorder.AddCall( "Slow", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }

    public virtual void Start()
    {
      TsmTrigger_IHowlers___Start tt = new TsmTrigger_IHowlers___Start();
      TsmRecorder.AddCall( "Start", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }

    public virtual void Stop()
    {
      TsmTrigger_IHowlers___Stop tt = new TsmTrigger_IHowlers___Stop();
      TsmRecorder.AddCall( "Stop", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }

    public virtual void Test()
    {
      TsmTrigger_IHowlers___Test tt = new TsmTrigger_IHowlers___Test();
      TsmRecorder.AddCall( "Test", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }
  }

  public interface ICbHowlers
  {
    void CbPaused();
    void CbSlowed();
    void CbStarted();
    void CbStopped();
    void CbOutSync();
  }

  public class TsmTrigger_ICbHowlers___CbPaused : TsmTrigger
  {
    public TsmTrigger_ICbHowlers___CbPaused()
      : base( 14 )
    {
    }
  }

  public class TsmTrigger_ICbHowlers___CbSlowed : TsmTrigger
  {
    public TsmTrigger_ICbHowlers___CbSlowed()
      : base( 15 )
    {
    }
  }

  public class TsmTrigger_ICbHowlers___CbStarted : TsmTrigger
  {
    public TsmTrigger_ICbHowlers___CbStarted()
      : base( 16 )
    {
    }
  }

  public class TsmTrigger_ICbHowlers___CbStopped : TsmTrigger
  {
    public TsmTrigger_ICbHowlers___CbStopped()
      : base( 17 )
    {
    }
  }

  public class TsmTrigger_ICbHowlers___CbOutSync : TsmTrigger
  {
    public TsmTrigger_ICbHowlers___CbOutSync()
      : base( 18 )
    {
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > ICbHowlers )
  public class TsmIPort_ICbHowlers : TsmInterfacePort, ICbHowlers
  {
    public TsmIPort_ICbHowlers( TsmBase oParent )
    {
      TsmName = "ICbHowlers";
      TsmParent = oParent;
    }

    public virtual void CbPaused()
    {
      TsmTrigger_ICbHowlers___CbPaused tt = new TsmTrigger_ICbHowlers___CbPaused();
      TsmRecorder.AddCall( "CbPaused", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }

    public virtual void CbSlowed()
    {
      TsmTrigger_ICbHowlers___CbSlowed tt = new TsmTrigger_ICbHowlers___CbSlowed();
      TsmRecorder.AddCall( "CbSlowed", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }

    public virtual void CbStarted()
    {
      TsmTrigger_ICbHowlers___CbStarted tt = new TsmTrigger_ICbHowlers___CbStarted();
      TsmRecorder.AddCall( "CbStarted", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }

    public virtual void CbStopped()
    {
      TsmTrigger_ICbHowlers___CbStopped tt = new TsmTrigger_ICbHowlers___CbStopped();
      TsmRecorder.AddCall( "CbStopped", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }

    public virtual void CbOutSync()
    {
      TsmTrigger_ICbHowlers___CbOutSync tt = new TsmTrigger_ICbHowlers___CbOutSync();
      TsmRecorder.AddCall( "CbOutSync", this.Source, this.Messager );
      tt.PortId = this.PortId;
      tt.IsForeign = (this.Source==null);
      this.Messager.Handle( tt );
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > HowlersServerPsm >> InitialState )
  public class Ini_0193_0194 : TsmPseudo
  {
    public Ini_0193_0194( TsmBase oParent )
    {
      TsmName = "InitialState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 212, "( HowlersServerPsm >> InitialState ) => ( HowlersServerPsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 212; // TRLS ( HowlersServerPsm >> InitialState ) => ( HowlersServerPsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 212: // UP: ( HowlersServerPsm >> InitialState ) => ( HowlersServerPsm >> Idle )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > HowlersServerPsm >> JuncState )
  public class Jun_0193_0195 : TsmPseudo
  {
    public Jun_0193_0195( TsmBase oParent )
    {
      TsmName = "JuncState";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 214, "( HowlersServerPsm >> JuncState ) => ( HowlersServerPsm >> Active >> Slow )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 214; // TRLS ( HowlersServerPsm >> JuncState ) => ( HowlersServerPsm >> Active >> Slow )
      mTransitions[ 0 ].bVisit = true;
    }

    public void Tra_0197_0207( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 214: // UP: ( HowlersServerPsm >> JuncState ) => ( HowlersServerPsm >> Active >> Slow )
        bHigher = true;
        break;
      case 207:
        Tra_0197_0207( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > HowlersServerPsm >> Active >> Starting )
  public class Lea_0197_0198 : TsmLeaf
  {
    int [] aNatives = { 209 };

    public Lea_0197_0198( TsmBase oParent )
    {
      TsmName = "Starting";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 209, "( HowlersServerPsm >> Active >> Starting ) => ( HowlersServerPsm >> Active >> Busy )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0193_0213( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 209:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 209: // Native: ( HowlersServerPsm >> Active >> Starting ) => ( HowlersServerPsm >> Active >> Busy )
          TsmRecorder.AddNative( "( HowlersServerPsm >> Active >> Starting ) => ( HowlersServerPsm >> Active >> Busy ) # CbStarted();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 209;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 209: // UP: ( HowlersServerPsm >> Active >> Starting ) => ( HowlersServerPsm >> Active >> Busy )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 213:
        Tra_0193_0213( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > HowlersServerPsm >> Active >> OutSync )
  public class Lea_0197_0199 : TsmLeaf
  {
    public Lea_0197_0199( TsmBase oParent )
    {
      TsmName = "OutSync";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0197_0205( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 205:
        Tra_0197_0205( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > HowlersServerPsm >> Active >> Slow )
  public class Lea_0197_0200 : TsmLeaf
  {
    public Lea_0197_0200( TsmBase oParent )
    {
      TsmName = "Slow";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    public void Tra_0193_0214( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 214:
        Tra_0193_0214( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > HowlersServerPsm >> Active >> Busy )
  public class Lea_0197_0201 : TsmLeaf
  {
    int [] aNatives = { 205 };

    public Lea_0197_0201( TsmBase oParent )
    {
      TsmName = "Busy";
      TsmParent = oParent;
      mNrTransitions = 4;
      mTransitions = new TsmTransition[ 4 ];
      mTransitions[ 0 ] = new TsmTransition( 205, "( HowlersServerPsm >> Active >> Busy ) => ( HowlersServerPsm >> Active >> OutSync )" );
      mTransitions[ 1 ] = new TsmTransition( 208, "( HowlersServerPsm >> Active >> Busy ) => ( HowlersServerPsm >> Active >> Pausing ) : Pause" );
      mTransitions[ 2 ] = new TsmTransition( 207, "( HowlersServerPsm >> Active >> Busy ) => ( HowlersServerPsm >> JuncState ) : Slow" );
      mTransitions[ 3 ] = new TsmTransition( 206, "( HowlersServerPsm >> Active >> Busy ) => ( HowlersServerPsm >> Active >> Test ) : Test" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0197_0209( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Tra_0197_0204( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Port___Pause( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 208; // Pause
      oHandler.bTaken = true;
      mTransitions[ 1 ].bVisit = true;
    }

    public void Port___Slow( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 207; // Slow
      oHandler.bTaken = true;
      mTransitions[ 2 ].bVisit = true;
    }

    public void Port___Test( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 206; // Test
      oHandler.bTaken = true;
      mTransitions[ 3 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 205:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port -1
      case 191:
        switch ( Command )
        {
        case 3:
          return TsmProspect.OK;
        case 4:
          return TsmProspect.OK;
        case 7:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 205: // Native: ( HowlersServerPsm >> Active >> Busy ) => ( HowlersServerPsm >> Active >> OutSync )
          TsmRecorder.AddNative( "( HowlersServerPsm >> Active >> Busy ) => ( HowlersServerPsm >> Active >> OutSync ) # CbOutSync();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 205;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break; // end of Port -1
      case 191: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 3: // Port___Pause
          {
            Port___Pause( oHandler );
          }
          break;
        case 4: // Port___Slow
          {
            Port___Slow( oHandler );
          }
          break;
        case 7: // Port___Test
          {
            Port___Test( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 209:
        Tra_0197_0209( oHandler );
        break;
      case 205: // UP: ( HowlersServerPsm >> Active >> Busy ) => ( HowlersServerPsm >> Active >> OutSync )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 204:
        Tra_0197_0204( oHandler );
        break;
      case 208: // UP: ( HowlersServerPsm >> Active >> Busy ) => ( HowlersServerPsm >> Active >> Pausing )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 207: // UP: ( HowlersServerPsm >> Active >> Busy ) => ( HowlersServerPsm >> JuncState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 206: // UP: ( HowlersServerPsm >> Active >> Busy ) => ( HowlersServerPsm >> Active >> Test )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > HowlersServerPsm >> Active >> Pausing )
  public class Lea_0197_0202 : TsmLeaf
  {
    int [] aNatives = { 204 };

    public Lea_0197_0202( TsmBase oParent )
    {
      TsmName = "Pausing";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 204, "( HowlersServerPsm >> Active >> Pausing ) => ( HowlersServerPsm >> Active >> Busy )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0197_0208( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 204:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 204: // Native: ( HowlersServerPsm >> Active >> Pausing ) => ( HowlersServerPsm >> Active >> Busy )
          TsmRecorder.AddNative( "( HowlersServerPsm >> Active >> Pausing ) => ( HowlersServerPsm >> Active >> Busy ) # CbPaused();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 204;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 204: // UP: ( HowlersServerPsm >> Active >> Pausing ) => ( HowlersServerPsm >> Active >> Busy )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 208:
        Tra_0197_0208( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > HowlersServerPsm >> Active >> Test )
  public class Lea_0197_0203 : TsmLeaf
  {
    public Lea_0197_0203( TsmBase oParent )
    {
      TsmName = "Test";
      TsmParent = oParent;
      mNrTransitions = 0;
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0197_0206( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 206:
        Tra_0197_0206( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > HowlersServerPsm >> Active >)
  public class Reg_0196_0197 : TsmRegion
  {
    private Lea_0197_0198 oLea_0197_0198; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > HowlersServerPsm >> Active >> Starting )
    private Lea_0197_0199 oLea_0197_0199; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > HowlersServerPsm >> Active >> OutSync )
    private Lea_0197_0200 oLea_0197_0200; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > HowlersServerPsm >> Active >> Slow )
    private Lea_0197_0201 oLea_0197_0201; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > HowlersServerPsm >> Active >> Busy )
    private Lea_0197_0202 oLea_0197_0202; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > HowlersServerPsm >> Active >> Pausing )
    private Lea_0197_0203 oLea_0197_0203; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > HowlersServerPsm >> Active >> Test )

    public Reg_0196_0197( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oLea_0197_0198 = new Lea_0197_0198( this );
      oLea_0197_0199 = new Lea_0197_0199( this );
      oLea_0197_0200 = new Lea_0197_0200( this );
      oLea_0197_0201 = new Lea_0197_0201( this );
      oLea_0197_0202 = new Lea_0197_0202( this );
      oLea_0197_0203 = new Lea_0197_0203( this );
      mNrStates = 6;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oLea_0197_0198;
      mStates[ 1 ] = oLea_0197_0199;
      mStates[ 2 ] = oLea_0197_0200;
      mStates[ 3 ] = oLea_0197_0201;
      mStates[ 4 ] = oLea_0197_0202;
      mStates[ 5 ] = oLea_0197_0203;
    }

     // Down: ( HowlersServerPsm >> JuncState ) => ( HowlersServerPsm >> Active >> Slow )
    public void Tra_0193_0214( TsmHandler oHandler )
    {
      mCurrentState = oLea_0197_0200; // Down: ( HowlersServerPsm >> Active >> Slow )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersServerPsm >> Active >> Starting ) => ( HowlersServerPsm >> Active >> Busy )
    public void Tra_0197_0209( TsmHandler oHandler )
    {
      ((Cla_0161_0190)oHandler.Owner).Function_1018( oHandler );
      mCurrentState = oLea_0197_0201; // At: ( HowlersServerPsm >> Active >> Busy )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersServerPsm >> Active >> Busy ) => ( HowlersServerPsm >> Active >> OutSync )
    public void Tra_0197_0205( TsmHandler oHandler )
    {
      ((Cla_0161_0190)oHandler.Owner).Function_1019( oHandler );
      mCurrentState = oLea_0197_0199; // At: ( HowlersServerPsm >> Active >> OutSync )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersServerPsm >> Active >> Pausing ) => ( HowlersServerPsm >> Active >> Busy )
    public void Tra_0197_0204( TsmHandler oHandler )
    {
      ((Cla_0161_0190)oHandler.Owner).Function_1020( oHandler );
      mCurrentState = oLea_0197_0201; // At: ( HowlersServerPsm >> Active >> Busy )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersServerPsm >> Active >> Busy ) => ( HowlersServerPsm >> Active >> Pausing )
    public void Tra_0197_0208( TsmHandler oHandler )
    {
      mCurrentState = oLea_0197_0202; // At: ( HowlersServerPsm >> Active >> Pausing )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // Down: ( HowlersServerPsm >> Idle ) => ( HowlersServerPsm >> Active >> Starting )
    public void Tra_0193_0213( TsmHandler oHandler )
    {
      mCurrentState = oLea_0197_0198; // Down: ( HowlersServerPsm >> Active >> Starting )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersServerPsm >> Active >> Busy ) => ( HowlersServerPsm >> Active >> Test )
    public void Tra_0197_0206( TsmHandler oHandler )
    {
      mCurrentState = oLea_0197_0203; // At: ( HowlersServerPsm >> Active >> Test )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 209:
          return TsmProspect.OK;
        case 205:
          return TsmProspect.OK;
        case 204:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port -1
      case 191:
        switch ( Command )
        {
        case 3:
          return TsmProspect.OK;
        case 4:
          return TsmProspect.OK;
        case 7:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 214:
        Tra_0193_0214( oHandler );
        break;
      case 209:
        Tra_0197_0209( oHandler );
        break;
      case 205:
        Tra_0197_0205( oHandler );
        break;
      case 204:
        Tra_0197_0204( oHandler );
        break;
      case 208:
        Tra_0197_0208( oHandler );
        break;
      case 207: // Up: ( HowlersServerPsm >> Active >> Busy ) => ( HowlersServerPsm >> JuncState )
        mCurrentState = null;
        bHigher = true;
        break;
      case 213:
        Tra_0193_0213( oHandler );
        break;
      case 206:
        Tra_0197_0206( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > HowlersServerPsm >> Active )
  public class Com_0193_0196 : TsmCompound
  {
    private Reg_0196_0197 oReg_0196_0197; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > HowlersServerPsm >> Active >)

    public Com_0193_0196( TsmBase oParent )
    {
      TsmName = "Active";
      TsmParent = oParent;
      oReg_0196_0197 = new Reg_0196_0197( this );
      mRegions.Add( oReg_0196_0197 );
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 216, "( HowlersServerPsm >> Active ) => ( HowlersServerPsm >> Stopping ) : Stop" );
    }

    public void Tra_0193_0214( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      oReg_0196_0197.ExecuteHandler( oHandler );
    }

    public void Tra_0193_0213( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      oReg_0196_0197.ExecuteHandler( oHandler );
    }

    public void Port___Stop( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 216; // Stop
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 191:
        switch ( Command )
        {
        case 6:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTriggerCompound( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 191: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 6: // Port___Stop
          {
            Port___Stop( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 214:
        Tra_0193_0214( oHandler );
        break;
      case 207: // UP: ( HowlersServerPsm >> Active >> Busy ) => ( HowlersServerPsm >> JuncState )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 213:
        Tra_0193_0213( oHandler );
        break;
      case 216: // UP: ( HowlersServerPsm >> Active ) => ( HowlersServerPsm >> Stopping )
        AtExit( oHandler );
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > HowlersServerPsm >> Idle )
  public class Lea_0193_0210 : TsmLeaf
  {
    public Lea_0193_0210( TsmBase oParent )
    {
      TsmName = "Idle";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 213, "( HowlersServerPsm >> Idle ) => ( HowlersServerPsm >> Active >> Starting ) : Start" );
    }

    public void Tra_0193_0212( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0193_0215( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public void Port___Start( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 213; // Start
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case 191:
        switch ( Command )
        {
        case 5:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case 191: // Port Port
        switch ( oHandler.Trigger.Command )
        {
        case 5: // Port___Start
          {
            Port___Start( oHandler );
          }
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 212:
        Tra_0193_0212( oHandler );
        break;
      case 215:
        Tra_0193_0215( oHandler );
        break;
      case 213: // UP: ( HowlersServerPsm >> Idle ) => ( HowlersServerPsm >> Active >> Starting )
        bHigher = true;
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > HowlersServerPsm >> Stopping )
  public class Lea_0193_0211 : TsmLeaf
  {
    int [] aNatives = { 215 };

    public Lea_0193_0211( TsmBase oParent )
    {
      TsmName = "Stopping";
      TsmParent = oParent;
      mNrTransitions = 1;
      mTransitions = new TsmTransition[ 1 ];
      mTransitions[ 0 ] = new TsmTransition( 215, "( HowlersServerPsm >> Stopping ) => ( HowlersServerPsm >> Idle )" );
    }

    public override void Initial( TsmHandler oHandler )
    {
      oHandler.Action = TsmHandlerAction.OK;
    }

    public void Tra_0193_0216( TsmHandler oHandler )
    {
      AtEntry( oHandler );
      Initial( oHandler );
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
      TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
    }

    public override void AtExit( TsmHandler oHandler )
    {
      TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 215:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override void ExecuteTrigger( TsmHandler oHandler )
    {
      switch ( oHandler.Trigger.PortId )
      {
      case -1: // Port NativePort
        switch ( oHandler.Trigger.Command )
        {
        case 215: // Native: ( HowlersServerPsm >> Stopping ) => ( HowlersServerPsm >> Idle )
          TsmRecorder.AddNative( "( HowlersServerPsm >> Stopping ) => ( HowlersServerPsm >> Idle ) # CbStopped();" );
          oHandler.Action = TsmHandlerAction.TRANSITION;
          oHandler.Index  = 215;
          oHandler.bTaken = true;
          mTransitions[ 0 ].bVisit = true;
          break;
        default:
          oHandler.Action = TsmHandlerAction.NOK;
          break;
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 215: // UP: ( HowlersServerPsm >> Stopping ) => ( HowlersServerPsm >> Idle )
        AtExit( oHandler );
        bHigher = true;
        break;
      case 216:
        Tra_0193_0216( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > HowlersServerPsm >)
  public class Reg_0192_0193 : TsmRegion
  {
    private Ini_0193_0194 oIni_0193_0194; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > HowlersServerPsm >> InitialState )
    private Jun_0193_0195 oJun_0193_0195; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > HowlersServerPsm >> JuncState )
    private Com_0193_0196 oCom_0193_0196; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > HowlersServerPsm >> Active )
    private Lea_0193_0210 oLea_0193_0210; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > HowlersServerPsm >> Idle )
    private Lea_0193_0211 oLea_0193_0211; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > HowlersServerPsm >> Stopping )

    public Reg_0192_0193( TsmBase oParent )
    {
      TsmName = "";
      TsmParent = oParent;
      oIni_0193_0194 = new Ini_0193_0194( this );
      oJun_0193_0195 = new Jun_0193_0195( this );
      oCom_0193_0196 = new Com_0193_0196( this );
      oLea_0193_0210 = new Lea_0193_0210( this );
      oLea_0193_0211 = new Lea_0193_0211( this );
      mNrStates = 5;
      mStates = new TsmState[ mNrStates ];
      mStates[ 0 ] = oIni_0193_0194;
      mStates[ 1 ] = oJun_0193_0195;
      mStates[ 2 ] = oCom_0193_0196;
      mStates[ 3 ] = oLea_0193_0210;
      mStates[ 4 ] = oLea_0193_0211;
    }

    public override void Initial( TsmHandler oHandler )
    {
      mbFinal = false;
      oHandler.Action = TsmHandlerAction.ENTER;
      oIni_0193_0194.ExecuteHandler( oHandler );
    }

     // At: ( HowlersServerPsm >> InitialState ) => ( HowlersServerPsm >> Idle )
    public void Tra_0193_0212( TsmHandler oHandler )
    {
      mCurrentState = oLea_0193_0210; // At: ( HowlersServerPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersServerPsm >> JuncState ) => ( HowlersServerPsm >> Active >> Slow )
    public void Tra_0193_0214( TsmHandler oHandler )
    {
      mCurrentState = oCom_0193_0196; // At: ( HowlersServerPsm >> Active )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersServerPsm >> Stopping ) => ( HowlersServerPsm >> Idle )
    public void Tra_0193_0215( TsmHandler oHandler )
    {
      ((Cla_0161_0190)oHandler.Owner).Function_1021( oHandler );
      mCurrentState = oLea_0193_0210; // At: ( HowlersServerPsm >> Idle )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersServerPsm >> Active >> Busy ) => ( HowlersServerPsm >> JuncState )
    public void Tra_0197_0207( TsmHandler oHandler )
    {
      mCurrentState = oJun_0193_0195; // At: ( HowlersServerPsm >> JuncState )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersServerPsm >> Idle ) => ( HowlersServerPsm >> Active >> Starting )
    public void Tra_0193_0213( TsmHandler oHandler )
    {
      mCurrentState = oCom_0193_0196; // At: ( HowlersServerPsm >> Active )
      mCurrentState.ExecuteHandler( oHandler );
    }

     // At: ( HowlersServerPsm >> Active ) => ( HowlersServerPsm >> Stopping )
    public void Tra_0193_0216( TsmHandler oHandler )
    {
      mCurrentState = oLea_0193_0211; // At: ( HowlersServerPsm >> Stopping )
      mCurrentState.ExecuteHandler( oHandler );
    }

    public override TsmProspect GetProspect( int PortId, int Command )
    {
      switch ( PortId )
      {
      case -1:
        switch ( Command )
        {
        case 209:
          return TsmProspect.OK;
        case 205:
          return TsmProspect.OK;
        case 204:
          return TsmProspect.OK;
        case 215:
          return TsmProspect.OK;
        default:
          break;
        }
        break; // end of Port -1
      case 191:
        switch ( Command )
        {
        case 3:
          return TsmProspect.OK;
        case 4:
          return TsmProspect.OK;
        case 5:
          return TsmProspect.OK;
        case 6:
          return TsmProspect.OK;
        case 7:
          return TsmProspect.OK;
        default:
          break;
        }
        break;
      default:
        break;
      }

      return TsmProspect.NOK;
    }

    public override bool ExecuteTransition( TsmHandler oHandler )
    {
      bool bHigher = false;
      switch ( oHandler.Index )
      {
      case 212:
        Tra_0193_0212( oHandler );
        break;
      case 214:
        Tra_0193_0214( oHandler );
        break;
      case 215:
        Tra_0193_0215( oHandler );
        break;
      case 207:
        Tra_0197_0207( oHandler );
        break;
      case 213:
        Tra_0193_0213( oHandler );
        break;
      case 216:
        Tra_0193_0216( oHandler );
        break;
      default:
        throw new TsmException( "Unknown Index " + oHandler.Index );
      }
      return bHigher;
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > HowlersServerPsm )
  public class Fsm_0190_0192 : TsmFsm
  {
    private Reg_0192_0193 oReg_0192_0193; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > HowlersServerPsm >)

    public Fsm_0190_0192( TsmBase oParent )
    {
      TsmName = "HowlersServerPsm";
      TsmParent = oParent;
      oReg_0192_0193 = new Reg_0192_0193( this );
      mRegions.Add( oReg_0192_0193 );
      mNrTransitions = 0;
    }

    public override void AtEntry( TsmHandler oHandler )
    {
      bVisit = true;
    }
  }

   // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer )
  public class Cla_0161_0190 : TsmProtocolClass
  {
    private Fsm_0190_0192 oFsm_0190_0192; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > HowlersServerPsm )
    private TsmIPort_IHowlers TsmPI__Port; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > Port )
    private TsmIPort_ICbHowlers Port; // ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer > Port )
    private TsmPSPort mPSMessager;

    public Cla_0161_0190( TsmBase oParent, string sInstanceName )
    {
      TsmName = sInstanceName;
      TsmParent = oParent;
      oFsm_0190_0192 = new Fsm_0190_0192( this );
      TsmPI__Port = new TsmIPort_IHowlers( this );
      mPSMessager = new TsmPSPort();
      oFsms = new TsmFsm[ 1 ];
      oFsms[ 0 ] = oFsm_0190_0192;
    }

    public override TsmInterfacePort GetProvidedInterface( string sPortName )
    {
      switch( sPortName )
      {
      case "Port" :
        return TsmPI__Port;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer )";
      throw new TsmException( s );
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "Port" :
        Port = (TsmIPort_ICbHowlers) oProvidedInterface;
        Port.Source = this;
        return;
      default :
        break;
      }
      string s;
      s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > HowlersProtocol > HowlersServer )";
      throw new TsmException( s );
    }

    public override void ExecuteTrigger( TsmTrigger oTrigger )
    {
      SnapCall = oTrigger.Snap();
      TsmHandler lHandler = new TsmHandler( this, oTrigger );
      oFsm_0190_0192.ExecuteTriggerFsm( lHandler );
      SnapCall = "";
      SnapState = null;
    }

     // ( HowlersServerPsm >> Active >> Starting ) => ( HowlersServerPsm >> Active >> Busy )
    public void Function_1018( TsmHandler oHandler )
    {
      Port.CbStarted();
    }

     // ( HowlersServerPsm >> Active >> Busy ) => ( HowlersServerPsm >> Active >> OutSync )
    public void Function_1019( TsmHandler oHandler )
    {
      Port.CbOutSync();
    }

     // ( HowlersServerPsm >> Active >> Pausing ) => ( HowlersServerPsm >> Active >> Busy )
    public void Function_1020( TsmHandler oHandler )
    {
      Port.CbPaused();
    }

     // ( HowlersServerPsm >> Stopping ) => ( HowlersServerPsm >> Idle )
    public void Function_1021( TsmHandler oHandler )
    {
      Port.CbStopped();
    }

    public override void TsmInitialise( object oObject )
    {
      TsmPI__Port.PortId = 191;
      TsmPI__Port.Messager = mPSMessager;
    }

    public override void TsmConnect( object oObject )
    {
      mPSMessager.Target = this;
    }

    public override void TsmPrepare( object oObject )
    {
      TsmHandler lHandler = new TsmHandler( this );
      lHandler.Action = TsmHandlerAction.ENTER;
      oFsm_0190_0192.ExecuteHandler( lHandler );
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols > HowlersProtocol )
   ********************************************************************/

   // ( Xmi > Data > Protocols > HowlersProtocol )
  public class Pac_0108_0161 : TsmPackage
  {
    public Pac_0108_0161( TsmBase oParent )
    {
      TsmName = "HowlersProtocol";
      TsmParent = oParent;
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > Protocols )
   ********************************************************************/

   // ( Xmi > Data > Protocols )
  public class Pac_0001_0108 : TsmPackage
  {
    public Pac_0001_0108( TsmBase oParent )
    {
      TsmName = "Protocols";
      TsmParent = oParent;
    }
  }

  /********************************************************************
   * PACKAGE: ( Xmi > Data > TismStereotypes )
   ********************************************************************/

   // ( Xmi > Data > TismStereotypes )
  public class Pac_0001_0217 : TsmPackage
  {
    public Pac_0001_0217( TsmBase oParent )
    {
      TsmName = "TismStereotypes";
      TsmParent = oParent;
    }
  }

   // ( Xmi )
  public class TsmSystem : TsmExecComponent
  {
    private Com_0002_0008 ExecEnv1; // ( Xmi > Data > Architecture > ExecEnv1 )

    public TsmSystem( TsmBase oParent )
    {
      TsmName = "Xmi";
      TsmParent = oParent;
      mNrComponents = 1;
      mComponents = new TsmComponent[ 1 ];
      ExecEnv1 = new Com_0002_0008( null, "ExecEnv1" );
      mComponents[ 0 ] = ExecEnv1;
    }
  }
}
